<?php
namespace Geral\Entities;

use Geral\Util\Ambiente;
use Geral\Util\DateUtil;

class Tipocusto extends Base\Tipocusto
{
    public static function atualizaTipoCustoPorMoeda(
        $nrorg, $idmoedcusto, $iduttpcusto
    )
    {
        try {
            $tipocusto = self::getObjectsByWhere(
                'NRORG = ? AND IDMOEDCUSTO = ?', array($nrorg, $idmoedcusto)
            );

            $dataAtual = DateUtil::getDataAtual();
            $operador  = Ambiente::getCdoperador();
            foreach ($tipocusto as $tpcusto) {
                $connection = \Setforms2\Shared\Registry::getEntityManager();
                $connection->beginTransaction();

                $tpcusto->setIduttpcusto($iduttpcusto);
                $tpcusto->setNrorgultatu($nrorg);
                $tpcusto->setCdoperultatu($operador);
                $tpcusto->setDtultatu($dataAtual);

                $tpcusto->persist();

                $connection->flush();
                $connection->commit();
            }

            return true;
        } catch (\Exception $e) {
            $connection->rollback();
            throw $e;
        }
    }
}