<?php
namespace Teknisa\Repositories;

use Setforms2\Shared\Registry;
use Symfony\Component\Translation\Tests\String;

class SitLogprod extends \Doctrine\ORM\EntityRepository
{

    /**
     * Busca Registros
     *
     * @param String $nrorg     Organização
     * @param String $nrremessa Remessa
     *
     * @return null
     */
    public static  function sqlBuscaRegistros ($nrorg, $nrremessa)
    {
        $sql = <<<SQL
        SELECT *
        FROM SIT_LOGPROD
        WHERE NRORG     = :P_NRORG
          AND NRREMESSA = :P_NRREMESSA
        ORDER BY CDPRODUTO
SQL;

        $params = array('P_NRORG' => $nrorg, 'P_NRREMESSA' => $nrremessa);

        $entityManager = Registry::getEntityManager();
        $result = $entityManager->getConnection()->fetchAll($sql, $params);
        return $result;

    }

}