/*
@C:\WEB_649\Sql\End_Conv\Oracle\3983_EXPSTPO_GERA_EXPEDICAO.SQL
 Tecnisa - Tecnologia em Informtica

 Nome: GERA_EXPEDICAO

  Descrio:
  Procedure responsvel por realizar expedio

DROP TABLE ITEMEXPEDICAO;
DROP TABLE ERROITEMEXP;
DROP TABLE NFRELACITEMPED;

DELETE FROM ITEMEXPEDICAO;
DELETE FROM ERROITEMEXP;
DELETE FROM NFRELACITEMPED;

DECLARE
   V_CDFILIAL VARCHAR2(04);
   V_SEQEXP VARCHAR2(20);
   V_NRSEQEXP VARCHAR2(10);
   V_RESULT   VARCHAR2(06);
BEGIN
   V_CDFILIAL := '0002';
   NOVO_CODIGO('NREXPEDICAO' || V_CDFILIAL,V_SEQEXP);
   V_NRSEQEXP := SUBSTR(V_SEQEXP,11,10);
   INCLUI_DADOS_EXPEDICAO(V_CDFILIAL,V_NRSEQEXP,TRUNC(SYSDATE),'ITEM','000000218462','0000003130','0000000001',10);
   --INCLUI_DADOS_EXPEDICAO('0002',V_NRSEQEXP,TRUNC(SYSDATE),'ITEM','000000000707','0000000155','0000000002',35);
   GERA_EXPEDICAO(V_CDFILIAL, V_NRSEQEXP, NULL, NULL, NULL, NULL, NULL, null, null, NULL, V_RESULT);
   COMMIT;
END;

SELECT CDFILIAL, NREXPEDICAO, DTEXPEDICAO, IDSTATUSEXP
FROM EXPEDICAO
WHERE CDFILIAL = :CDFILIAL
  AND NREXPEDICAO = (SELECT MAX(NREXPEDICAO) FROM EXPEDICAO WHERE CDFILIAL = :CDFILIAL)
/
SELECT *
FROM EXPRELACITEMPPED
WHERE CDFILIAL = :CDFILIAL
AND NREXPEDICAO = :NREXPEDICAO
/
SELECT *
FROM ITEMEXPEDICAO
WHERE CDFILIAL = :CDFILIAL
  AND NREXPEDICAO = :NREXPEDICAO
  ORDER BY 1,2
/
SELECT *
FROM ERROITEMEXP
WHERE CDFILIAL = :CDFILIAL
AND NREXPEDICAO = :NREXPEDICAO
/
SELECT *
FROM NFRELACITEMPED
WHERE CDFILIAL = :CDFILIAL
AND NREXPEDICAO = :NREXPEDICAO
/
SELECT P.CDFILIAL, P.NRPEDIDO, P.IDSITPEDIDO, I.NRITEMPED, I.CDPRODUTO, I.QTITEMPED, I.QTEXPITEMPED, I.IDSITITEMPED
  FROM PEDIDO P JOIN ITEMPEDIDO I
                  ON P.CDFILIAL = I.CDFILIAL
                 AND P.NRPEDIDO = I.NRPEDIDO
                JOIN EXPRELACITEMPPED NP
                  ON I.CDFILIAL = NP.CDFILIAL
                 AND I.NRPEDIDO = NP.NRPEDIDO
                 AND I.NRITEMPED = NP.NRITEMPED
WHERE NP.CDFILIAL = :CDFILIAL
AND NP.NREXPEDICAO = :NREXPEDICAO
/



*/


CREATE OR REPLACE PROCEDURE GERA_EXPEDICAO
(P_CDFILIAL     IN EXPEDICAO.CDFILIAL%TYPE,
 P_NREXPEDICAO  IN EXPEDICAO.NREXPEDICAO%TYPE,
 P_CDEMPRESA    IN SERIENF.CDEMPRESA%TYPE     DEFAULT NULL,
 P_CDINSCESTA   IN SERIENF.CDINSCESTA%TYPE    DEFAULT NULL,
 P_CDINSCMUNI   IN SERIENF.CDINSCMUNI%TYPE    DEFAULT NULL,
 P_CDSERIE      IN SERIENF.CDSERIE%TYPE       DEFAULT NULL,
 P_CDTIPOOPER   IN TIPOOPERAC.CDTIPOOPER%TYPE DEFAULT NULL,
 P_CDSERIEENTR  IN SERIEENTR.CDSERIEENTR%TYPE DEFAULT NULL,
 P_CDTPOPERENTR IN TIPOOPERAC.CDTIPOOPER%TYPE DEFAULT NULL,
 P_CDTIPOCUSTO  IN TIPOCUSTO.CDTIPOCUSTO%TYPE DEFAULT NULL,
 P_IDSTATUSEXP OUT EXPEDICAO.IDSTATUSEXP%TYPE)
AS
   V_IDTABPRECO      PARAMPEDIDO.IDTABPRECO%TYPE;
   V_IDCALCPRECFAT   PARAMPEDIDO.IDCALCPRECFAT%TYPE;
   V_IDCUSEXP        PAREXPEDICAO.IDCUSEXP%TYPE;
   V_VRPRECO         ITEMPEDIDO.VRPREUNITPED%TYPE;
   V_VRCUSTO         ITEMPEDIDO.VRPREUNITPED%TYPE;
   V_VRFATPRECO      PRODFATOR.VRFATPRECO%TYPE;
   V_NRSEQ           ERROITEMEXP.NRSEQERROITEM%TYPE;
   V_IDOBRTPOPPED    PARAMPEDIDO.IDOBRTPOPPED%TYPE;
   V_IDDESTINO       ITEMEXPEDICAO.IDDESTINO%TYPE;
   V_CDDESTINO       ITEMEXPEDICAO.CDDESTINO%TYPE;
   V_IDUTVALIPED     PARAMPEDIDO.IDUTVALIPED%TYPE;
   V_IDCTRLESTQ      PARAMFILIAL.IDCTRLESTQ%TYPE;
   V_IDATUESTTPOP    TIPOOPERAC.IDATUESTTPOP%TYPE;
   V_IDUTILALMOX     PARAMFILIAL.IDUTILALMOX%TYPE;
   V_CDALMOXARIFE    PARAMFILIAL.CDALMOXARIFE%TYPE;
   V_CDALMOXEXP      ALMOXARIFADO.CDALMOXARIFE%TYPE;
   V_IDUTILLCESTQ    PARAMFILIAL.IDUTILLCESTQ%TYPE;
   V_CDLOCALESTOQ    PARAMFILIAL.CDLOCALESTOQ%TYPE;
   V_CDLOCALEXP      LOCALESTOQUE.CDLOCALESTOQ%TYPE;
   V_IDCNTRESTOQ     PRODFILI.IDCNTRESTOQ%TYPE;
   V_CDALMOXPRCLI    PRODFILI.CDALMOXPRCLI%TYPE;
   V_CDLOCALPRCLI    PRODFILI.CDLOCALPRCLI%TYPE;
   V_IDEMPRESANFEXP  PAREXPEDICAO.IDEMPRESANFEXP%TYPE;
   V_CDEMPRESA       EMPRESA.CDEMPRESA%TYPE;
   V_CDINSCESTA      INSCRESTAD.CDINSCESTA%TYPE;
   V_CDINSCMUNI      INSCRMUNICIP.CDINSCMUNI%TYPE;
   V_CDSERIE         SERIENF.CDSERIE%TYPE;
   V_PAREXP          INTEGER;
   V_IDPERADIEXP     PAREXPEDICAO.IDPERADIEXP%TYPE;
   V_VRPEADIEXP      PAREXPEDICAO.VRPEADIEXP%TYPE;
   V_QTMAXEXP        ITEMPEDIDO.QTITEMPED%TYPE;
   V_QTTOTAITEM      ITEMPEDIDO.QTITEMPED%TYPE;
   V_VRDESCEXP       ITEMPEDIDO.VRDESITPED%TYPE;
   V_IDGERPRODEST    PAREXPEDICAO.IDGERPRODEST%TYPE;
   V_CDPRODMOVI      PRODUTO.CDPRODUTO%TYPE;
   V_QTITEMPROD      ITEMPRODUTO.QTITEMPROD%TYPE;
   V_VRPESOLIQEXP    PRODUTO.VRPESOLIQUPR%TYPE;
   V_VRPESOBRUTOEXP  PRODUTO.VRPESOBRUTPR%TYPE;
   V_NRMAXITNF       SERIENF.NRMAXITNF%TYPE;
   V_SEQNF           NOVOCODIGO.NRSEQUENCIAL%TYPE;
   V_NRLANCTONF      NOTAFISCAL.NRLANCTONF%TYPE;
   V_SEQEST          NOVOCODIGO.NRSEQUENCIAL%TYPE;
   V_PRXLANCESTQ     LANCTOESTOQ.NRLANCESTQ%TYPE;
   V_ATUAESTOQUE     TIPOOPERAC.IDATUESTTPOP%TYPE;
   V_COUNTITEM       INTEGER;
   V_IDSITITEMPED    ITEMPEDIDO.IDSITITEMPED%TYPE;
   V_IDLANENCARGOPED PARAMPEDIDO.IDLANENCARGOPED%TYPE;
   V_NOVANOTA        INTEGER;
   V_DTPROCESSA      PARAMFILIAL.DTPROCESSA%TYPE;
   V_DTINICIAL       DATE;
   V_DTFINAL         DATE;
   V_DTANTERIOR      DATE;
   V_ERROESTOQ       INTEGER;
   V_ITEMPA          INTEGER;
   V_IDSITPEDIDO     PEDIDO.IDSITPEDIDO%TYPE;
   V_IDAGRUPAEXP     PAREXPEDICAO.IDAGRUPAEXP%TYPE;
   V_CDQUEBRANF      CLIENTE.CDCLIENTE%TYPE;
   V_IDGERANFPEDI    CLIENTE.IDGERANFPEDI%TYPE;
   V_EXISTERESERVA   INTEGER;
   V_ERRO            INTEGER;
   V_NAOOK           INTEGER;
   V_OKNF            INTEGER;
   V_OKITEMPED       INTEGER;
   V_DTEXPEDICAO     EXPEDICAO.DTEXPEDICAO%TYPE;
   V_CDOPERADOR      OPERADOR.CDOPERADOR%TYPE;
   V_EXISTENF        INTEGER;
   V_QTNF            INTEGER;
   V_IDUTCTRLLOTE    PRODFILI.IDUTCTRLLOTE%TYPE;
   V_QTEXPEDIDA      ITEMPEDIDO.QTITEMPED%TYPE;
   V_TOTALESTOQUE    ITEMPEDIDO.QTITEMPED%TYPE;
   V_IDGERAREPLIC    PAREXPEDICAO.IDGERAREPLIC%TYPE;
   V_IDUTILLOTE      PARAMFILIAL.IDUTILLOTE%TYPE;
   V_DSNUMELOTE      PARAMFILIAL.DSNUMELOTE%TYPE;
   V_DSSEQULOTE      PARAMFILIAL.DSSEQULOTE%TYPE;
   V_IDCONMAXITEM    SERIENF.IDCONMAXITEM%TYPE;
   V_CDTIPOOPER      TIPOOPERAC.CDTIPOOPER%TYPE;
   V_CDTIPOOPERORIG  TIPOOPERAC.CDTIPOOPER%TYPE;
   V_CDFILIDEST      PEDIDO.CDFILIALPED%TYPE;
   V_IDTIPOEXP       EXPRELACITEMPPED.IDTIPOEXP%TYPE;
   V_QTRESERVTOT     ITEMPEDIDO.QTITEMPED%TYPE;
   V_QTEXPEDIRMAX    ITEMPEDIDO.QTITEMPED%TYPE;
BEGIN
   BEGIN
      SELECT NVL(IDTABPRECO, '1'), NVL(IDCALCPRECFAT, 'E'), NVL(IDOBRTPOPPED, 'N'), NVL(IDUTVALIPED,'N'), NVL(IDLANENCARGOPED,'N')
        INTO V_IDTABPRECO,  V_IDCALCPRECFAT,  V_IDOBRTPOPPED,  V_IDUTVALIPED, V_IDLANENCARGOPED
        FROM PARAMPEDIDO
       WHERE CDFILIAL = P_CDFILIAL;
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_IDTABPRECO := '1';
         V_IDCALCPRECFAT := 'E';
         V_IDOBRTPOPPED  := 'N';
         V_IDUTVALIPED := 'N';
         V_IDLANENCARGOPED := 'N';
   END;

   BEGIN
      SELECT NVL(IDCUSEXP, '03'),   NVL(IDEMPRESANFEXP, 'EMPRESAFILIAL') ,   NVL(IDPERADIEXP,'N'),   NVL(VRPEADIEXP,0),   NVL(IDGERPRODEST, '1'), NVL(IDAGRUPAEXP,'C'),
             NVL(IDGERAREPLIC, '1'), COUNT(1)
        INTO V_IDCUSEXP, V_IDEMPRESANFEXP, V_IDPERADIEXP, V_VRPEADIEXP, V_IDGERPRODEST, V_IDAGRUPAEXP, V_IDGERAREPLIC, V_PAREXP
        FROM PAREXPEDICAO
       WHERE CDFILIAL = P_CDFILIAL
      GROUP BY NVL(IDCUSEXP, '03'),   NVL(IDEMPRESANFEXP, 'EMPRESAFILIAL') ,   NVL(IDPERADIEXP,'N'),   NVL(VRPEADIEXP,0),   NVL(IDGERPRODEST, '1'), NVL(IDAGRUPAEXP, 'C'),
               NVL(IDGERAREPLIC, '1');
   EXCEPTION
      WHEN NO_DATA_FOUND THEN BEGIN
         V_IDCUSEXP := '03';
         V_IDEMPRESANFEXP := 'EMPRESAFILIAL';
         V_PAREXP := 0;
         V_IDPERADIEXP := 'N';
         V_VRPEADIEXP := 0;
         V_IDGERPRODEST := '1';
         V_IDAGRUPAEXP := 'C';
         V_PAREXP := 0;
         V_IDGERAREPLIC := '1';
      END;
   END;

   BEGIN
      SELECT NVL(IDCTRLESTQ,'S'),   NVL(IDUTILALMOX,'N'),   CDALMOXARIFE,   NVL(IDUTILLCESTQ,'N'),   CDLOCALESTOQ,
             NVL(TRUNC(NVL(DTPROCESSA,SYSDATE)), TRUNC(SYSDATE))
        INTO V_IDCTRLESTQ, V_IDUTILALMOX, V_CDALMOXARIFE, V_IDUTILLCESTQ, V_CDLOCALESTOQ,
             V_DTPROCESSA
        FROM PARAMFILIAL
       WHERE CDFILIAL = P_CDFILIAL;
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_IDCTRLESTQ := 'S';
         V_IDUTILALMOX := 'N';
         V_CDALMOXARIFE := NULL;
         V_IDUTILLCESTQ := 'N';
         V_CDLOCALESTOQ := NULL;
         V_DTPROCESSA := TRUNC(SYSDATE);
   END;
   V_CDEMPRESA  := NULL;
   V_CDINSCESTA := NULL;
   V_CDINSCMUNI := NULL;
   V_CDSERIE    := NULL;
   IF (V_IDEMPRESANFEXP = 'EMPRESAFILIAL') THEN
      BEGIN
         SELECT CDEMPRESA,   CDINSCESTA,   CDINSCMUNI,   CDSERIE
           INTO V_CDEMPRESA, V_CDINSCESTA, V_CDINSCMUNI, V_CDSERIE
           FROM FILIAL
          WHERE CDFILIAL = P_CDFILIAL;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_CDEMPRESA  := NULL;
            V_CDINSCESTA := NULL;
            V_CDINSCMUNI := NULL;
            V_CDSERIE    := NULL;
      END;
   ELSE
      IF (V_IDEMPRESANFEXP = 'INFORMALANCEXP') THEN
         V_CDEMPRESA  := P_CDEMPRESA;
         V_CDINSCESTA := P_CDINSCESTA;
         V_CDINSCMUNI := P_CDINSCMUNI;
         V_CDSERIE    := P_CDSERIE;
      END IF;
   END IF;
   SELECT MAX(DTEXPEDICAO), MAX(CDOPERADOR)
     INTO V_DTEXPEDICAO, V_CDOPERADOR
     FROM EXPEDICAO
    WHERE CDFILIAL = P_CDFILIAL
      AND NREXPEDICAO = P_NREXPEDICAO;

   V_CDTIPOOPER := NULL;
   FOR C_ITEMEXP IN (SELECT CDFILIAL, NREXPEDICAO, NRPEDIDO, NRITEMPED , QTITEMEXP, IDTIPOEXP
                       FROM EXPRELACITEMPPED
                      WHERE CDFILIAL = P_CDFILIAL
                        AND NREXPEDICAO = P_NREXPEDICAO)
   LOOP

      /*LOOP NOS ITENS MARCADOS PARA EXPEDIR*/
      IF (C_ITEMEXP.IDTIPOEXP = 'ITEM') THEN
         FOR C_ITEM IN (SELECT I.CDFILIAL, I.NRPEDIDO, P.CDTIPOOPER, P.CDFILIALPED, P.CDCLIENTE, P.DTVALIPED, P.CDVENDEDOR,
                               P.IDTPIJURTRAN, P.NRINSJURTRAN, P.CDTIPTRANS, P.IDPGFRETTRAN, P.NRPLACAVEPED,  P.SGUFVEICPED, NVL(P.IDPEDINDUSTRIA, 'N') IDPEDINDUSTRIA,
                               P.CDMODPGTO , P.IDTPFORPGTPED , P.NRDIAPGFIXPED, P.NRPARCPGTOPED, P.IDUTDIAPAGPED,
                               I.NRITEMPED, PR.CDPRODUTO, PR.CDPRODESTO, PR.VRFATOCONV, PR.VRPESOBRUTPR, PR.VRPESOLIQUPR, I.IDSITITEMPED,
                               NVL(I.CDEMISSAOITPED, PR.CDARVPROD) AS CDPRODEMIS, NVL(I.DSEMISSAOITPED, PR.NMPRODUTO) AS DSPRODEMIS,
                               E.QTITEMEXP, I.QTITEMPED, I.QTEXPITEMPED, I.VRPREUNITPED, I.CDFATPRECO, I.VRDESITPED,
                               I.IDITEMPEDTERC
                          FROM ITEMPEDIDO I JOIN PRODUTO PR
                                              ON I.CDPRODUTO = PR.CDPRODUTO
                                            JOIN PEDIDO P
                                              ON I.CDFILIAL = P.CDFILIAL
                                             AND I.NRPEDIDO = P.NRPEDIDO
                                            JOIN EXPRELACITEMPPED E
                                              ON I.CDFILIAL = E.CDFILIAL
                                             AND I.NRPEDIDO = E.NRPEDIDO
                                             AND I.NRITEMPED = E.NRITEMPED
                         WHERE I.CDFILIAL = C_ITEMEXP.CDFILIAL
                           AND I.NRPEDIDO = C_ITEMEXP.NRPEDIDO
                           AND I.NRITEMPED = C_ITEMEXP.NRITEMPED
                           AND E.NREXPEDICAO = C_ITEMEXP.NREXPEDICAO)
         LOOP
            V_IDDESTINO := NULL;
            V_CDDESTINO := C_ITEM.CDCLIENTE;
            V_CDALMOXEXP := NULL;
            V_IDATUESTTPOP := NULL;
            V_IDCNTRESTOQ := NULL;

            BEGIN
               SELECT NVL(IDCNTRESTOQ,'S'),   CDALMOXPRCLI,   CDLOCALPRCLI, NVL(IDUTCTRLLOTE, 'S')
                 INTO V_IDCNTRESTOQ, V_CDALMOXPRCLI, V_CDLOCALPRCLI, V_IDUTCTRLLOTE
                 FROM PRODFILI
                WHERE CDFILIAL  = C_ITEM.CDFILIAL
                  AND CDPRODUTO = C_ITEM.CDPRODESTO;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_IDCNTRESTOQ := 'S';
                  V_CDALMOXPRCLI := NULL;
                  V_CDLOCALPRCLI := NULL;
                  V_IDUTCTRLLOTE := 'S';
            END;
            IF (V_IDOBRTPOPPED = 'S') THEN
               V_CDTIPOOPER := C_ITEM.CDTIPOOPER;
            ELSE
               V_CDTIPOOPER := P_CDTIPOOPER;
            END IF;
            IF (V_CDTIPOOPER IS NOT NULL) THEN
               BEGIN
                  SELECT NVL(IDORIGDESTOP, 'C'), NVL(IDATUESTTPOP, 'S')
                    INTO V_IDDESTINO,  V_IDATUESTTPOP
                    FROM TIPOOPERAC
                   WHERE IDENTRSAIDOP = 'S'
                     AND CDTIPOOPER = V_CDTIPOOPER;
               EXCEPTION
                  WHEN NO_DATA_FOUND THEN
                     V_IDDESTINO := 'C';
                     V_IDATUESTTPOP := 'S';
               END;
               IF (V_IDDESTINO = 'L') THEN
                  V_CDDESTINO := C_ITEM.CDFILIALPED;
               END IF;
               IF (V_IDCTRLESTQ = 'S') AND (V_IDATUESTTPOP = 'S') THEN
                  IF (V_IDCNTRESTOQ = 'S') THEN
                     IF (V_IDUTILALMOX = 'S') THEN
                        V_CDALMOXEXP := V_CDALMOXPRCLI;
                        IF (V_CDALMOXEXP IS NULL) THEN
                           V_CDALMOXEXP := V_CDALMOXARIFE;
                        END IF;
                     ELSE
                        V_CDALMOXEXP := ' ';
                     END IF;
                     IF (V_IDUTILLCESTQ = 'S') THEN
                        V_CDLOCALEXP := V_CDLOCALPRCLI;
                        IF (V_CDLOCALEXP IS NULL) THEN
                           V_CDLOCALEXP := V_CDLOCALESTOQ;
                        END IF;
                     ELSE
                        V_CDLOCALEXP := ' ';
                     END IF;
                  END IF;
               END IF;
            END IF;
            V_VRPRECO := C_ITEM.VRPREUNITPED;
            V_VRCUSTO := NULL;
            V_VRFATPRECO := NULL;
            IF ((V_IDTABPRECO = '2') AND (V_IDCALCPRECFAT = 'E')) THEN
               V_VRCUSTO := (PEDCUST_COMP_PROD(C_ITEM.CDPRODESTO, C_ITEM.CDFILIAL, V_IDCUSEXP, 1, '', SYSDATE, C_ITEM.CDFATPRECO, C_ITEM.NRPEDIDO, C_ITEM.NRITEMPED) * NVL(C_ITEM.VRFATOCONV,1));
               BEGIN
                  SELECT NVL(VRFATPRECO, 0)
                    INTO V_VRFATPRECO
                    FROM PRODFATOR
                   WHERE CDFATPRECO = C_ITEM.CDFATPRECO
                     AND CDPRODUTO  = C_ITEM.CDPRODUTO;
               EXCEPTION
                  WHEN NO_DATA_FOUND THEN
                     V_VRFATPRECO := 0;
               END;
               V_VRPRECO := V_VRCUSTO * V_VRFATPRECO;
            END IF;

            IF (V_IDEMPRESANFEXP = 'EMPRESACLIENTE') THEN
               BEGIN
                  SELECT CDEMPRESA,   CDINSCESTA,   CDINSCMUNI,   CDSERIE
                    INTO V_CDEMPRESA, V_CDINSCESTA, V_CDINSCMUNI, V_CDSERIE
                    FROM CLIENTE
                   WHERE CDCLIENTE = C_ITEM.CDCLIENTE;
               EXCEPTION
                  WHEN NO_DATA_FOUND THEN
                     V_CDEMPRESA := NULL;
                     V_CDINSCESTA := NULL;
                     V_CDINSCMUNI := NULL;
                     V_CDSERIE := NULL;
               END;
            END IF;
            V_QTMAXEXP := C_ITEM.QTITEMEXP;
            IF (V_IDPERADIEXP = 'S') THEN
               V_QTEXPEDIRMAX := (C_ITEM.QTITEMPED - C_ITEM.QTEXPITEMPED) * C_ITEM.VRFATOCONV;
               V_QTMAXEXP := ROUND(V_QTEXPEDIRMAX + ((V_QTEXPEDIRMAX*V_VRPEADIEXP)/100),5);
            END IF;

            V_QTTOTAITEM := (C_ITEM.QTEXPITEMPED + C_ITEM.QTITEMEXP);
            IF V_QTTOTAITEM > C_ITEM.QTITEMPED THEN
               V_QTTOTAITEM := C_ITEM.QTITEMEXP - (V_QTTOTAITEM - C_ITEM.QTITEMPED);
            ELSE
               V_QTTOTAITEM := C_ITEM.QTITEMEXP;
            END IF;
            IF V_QTTOTAITEM = 0 THEN
               V_QTTOTAITEM := 1;
            END IF;
            IF (C_ITEM.VRDESITPED > 0) THEN
               V_VRDESCEXP := C_ITEM.VRDESITPED / (C_ITEM.QTITEMPED/V_QTTOTAITEM);
            ELSE
               V_VRDESCEXP := 0;
            END IF;

            IF (V_IDGERPRODEST = '2') THEN
               V_CDPRODMOVI := C_ITEM.CDPRODESTO;
               V_QTITEMPROD := C_ITEM.QTITEMEXP * C_ITEM.VRFATOCONV;
               V_VRPRECO    := V_VRPRECO * C_ITEM.VRFATOCONV;
            ELSE
               V_CDPRODMOVI := C_ITEM.CDPRODUTO;
               V_QTITEMPROD := C_ITEM.QTITEMEXP;
            END IF;
            V_VRPESOLIQEXP   := V_QTITEMPROD * C_ITEM.VRPESOLIQUPR;
            V_VRPESOBRUTOEXP := V_QTITEMPROD * C_ITEM.VRPESOBRUTPR;

            IF (V_IDAGRUPAEXP = 'C') THEN
               BEGIN
                  SELECT NVL(IDGERANFPEDI, '2')
                    INTO V_IDGERANFPEDI
                    FROM CLIENTE
                   WHERE CDCLIENTE = C_ITEM.CDCLIENTE;
               EXCEPTION
                  WHEN NO_DATA_FOUND THEN BEGIN
                     V_IDGERANFPEDI := '2';
                  END;
               END;
               IF (V_IDGERANFPEDI = '1') THEN
                  V_CDQUEBRANF := C_ITEM.NRPEDIDO;
               ELSE
                  V_CDQUEBRANF := C_ITEM.CDCLIENTE;
               END IF;
            ELSE
               IF (C_ITEM.CDFILIALPED IS NOT NULL) THEN
                  V_CDQUEBRANF := C_ITEM.CDFILIALPED;
               ELSE
                  BEGIN
                     SELECT NVL(IDGERANFPEDI, '2')
                       INTO V_IDGERANFPEDI
                       FROM CLIENTE
                      WHERE CDCLIENTE = C_ITEM.CDCLIENTE;
                  EXCEPTION
                     WHEN NO_DATA_FOUND THEN BEGIN
                        V_IDGERANFPEDI := '2';
                     END;
                  END;
                  IF (V_IDGERANFPEDI = '1') THEN
                     V_CDQUEBRANF := C_ITEM.NRPEDIDO;
                  ELSE
                     V_CDQUEBRANF := C_ITEM.CDCLIENTE;
                  END IF;
               END IF;
            END IF;
            V_EXISTERESERVA := 0;
            SELECT COUNT(1)
              INTO V_EXISTERESERVA
              FROM RESERPRODPED
             WHERE CDFILIAL = C_ITEM.CDFILIAL
               AND NRPEDIDO = C_ITEM.NRPEDIDO
               AND NRITEMPED = C_ITEM.NRITEMPED;

            IF (V_EXISTERESERVA >= 1) THEN
               FOR C_RESERVA IN (SELECT CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, QTRESPRODPED
                                   FROM RESERPRODPED
                                  WHERE CDFILIAL = C_ITEM.CDFILIAL
                                    AND NRPEDIDO = C_ITEM.NRPEDIDO
                                    AND NRITEMPED = C_ITEM.NRITEMPED)
               LOOP
                  IF (V_IDGERPRODEST = '2') THEN
                     V_QTITEMPROD := C_RESERVA.QTRESPRODPED;
                     V_VRPRECO    := V_VRPRECO * C_ITEM.VRFATOCONV;
                  ELSE
                     V_QTITEMPROD := C_RESERVA.QTRESPRODPED/C_ITEM.VRFATOCONV;
                  END IF;

                  V_VRPESOLIQEXP   := V_QTITEMPROD * C_ITEM.VRPESOLIQUPR;
                  V_VRPESOBRUTOEXP := V_QTITEMPROD * C_ITEM.VRPESOBRUTPR;

                  SELECT NVL(MAX(NRSEQITEMEXP),0)
                    INTO V_NRSEQ
                    FROM ITEMEXPEDICAO
                   WHERE CDFILIAL = P_CDFILIAL
                     AND NREXPEDICAO = P_NREXPEDICAO
                     AND NRPEDIDO = C_ITEM.NRPEDIDO
                     AND NRITEMPED = C_ITEM.NRITEMPED;

                  V_NRSEQ := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_NRSEQ) + 1)),10,0);

                  INSERT INTO ITEMEXPEDICAO
                  (CDFILIAL, NREXPEDICAO, NRPEDIDO, CDTIPOOPER, IDATUESTTPOP, IDDESTINO, CDFILIALPED, CDCLIENTE, CDDESTINO, DTVALIPED,
                   IDTPIJURTRAN, NRINSJURTRAN, CDTIPTRANS, IDPGFRETTRAN, NRPLACAVEPED,  SGUFVEICPED,
                   CDEMPRESA,   CDINSCESTA,   CDINSCMUNI,   CDSERIE, IDPEDINDUSTRIA, CDVENDEDOR,
                   CDMODPGTO , IDTPFORPGTPED , NRDIAPGFIXPED, NRPARCPGTOPED, IDUTDIAPAGPED, IDAGRUPAEXP, IDGERANFPEDI, CDQUEBRANF,
                   NRITEMPED, CDPRODUTO, CDPRODMOVI, VRFATOCONV, IDCNTRESTOQ, IDSITITEMPED, CDPRODEMIS, DSPRODEMIS, VRPESOLIQ, VRPESOBRUTO,
                   QTITEMEXP, QTMAXEXP, QTITEMPROD, QTITEMPED, QTEXPEDIDA, IDUTILALMOX, CDALMOXEXP, IDUTILLCESTQ, CDLOCALEXP,
                   VRPRECOEXP, VRCUSTO, VRFATPRECO, VRDESITEXP, IDITEMPEDTERC, IDUTCTRLLOTE,
                   IDRESERVA, QTRESERVADA, NRLOTEEXP, NRSUBLOTEEXP, NRSEQITEMEXP, IDERRO)
                  VALUES
                  (C_ITEM.CDFILIAL, P_NREXPEDICAO, C_ITEM.NRPEDIDO, V_CDTIPOOPER, V_IDATUESTTPOP, V_IDDESTINO, C_ITEM.CDFILIALPED, C_ITEM.CDCLIENTE, V_CDDESTINO,C_ITEM.DTVALIPED,
                   C_ITEM.IDTPIJURTRAN, C_ITEM.NRINSJURTRAN, C_ITEM.CDTIPTRANS, C_ITEM.IDPGFRETTRAN, C_ITEM.NRPLACAVEPED,  C_ITEM.SGUFVEICPED,
                   V_CDEMPRESA, V_CDINSCESTA, V_CDINSCMUNI, V_CDSERIE, C_ITEM.IDPEDINDUSTRIA, C_ITEM.CDVENDEDOR,
                   C_ITEM.CDMODPGTO , C_ITEM.IDTPFORPGTPED , C_ITEM.NRDIAPGFIXPED, C_ITEM.NRPARCPGTOPED, C_ITEM.IDUTDIAPAGPED, V_IDAGRUPAEXP, V_IDGERANFPEDI, V_CDQUEBRANF,
                   C_ITEM.NRITEMPED,  C_ITEM.CDPRODUTO, V_CDPRODMOVI, C_ITEM.VRFATOCONV, V_IDCNTRESTOQ, C_ITEM.IDSITITEMPED, C_ITEM.CDPRODEMIS, C_ITEM.DSPRODEMIS, V_VRPESOLIQEXP, V_VRPESOBRUTOEXP,
                   C_ITEM.QTITEMEXP, V_QTMAXEXP, V_QTITEMPROD, C_ITEM.QTITEMPED, C_ITEM.QTEXPITEMPED, V_IDUTILALMOX, C_RESERVA.CDALMOXARIFE, V_IDUTILLCESTQ, C_RESERVA.CDLOCALESTOQ,
                   V_VRPRECO, V_VRCUSTO, V_VRFATPRECO, V_VRDESCEXP, C_ITEM.IDITEMPEDTERC, V_IDUTCTRLLOTE,
                   'S', C_RESERVA.QTRESPRODPED, C_RESERVA.NRLOTEESTQ, C_RESERVA.NRSUBLOTE, V_NRSEQ, 'N');
               END LOOP;
            ELSE
               SELECT NVL(MAX(NRSEQITEMEXP),0)
                 INTO V_NRSEQ
                 FROM ITEMEXPEDICAO
                WHERE CDFILIAL = P_CDFILIAL
                  AND NREXPEDICAO = P_NREXPEDICAO
                  AND NRPEDIDO = C_ITEM.NRPEDIDO
                  AND NRITEMPED = C_ITEM.NRITEMPED;

               V_NRSEQ := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_NRSEQ) + 1)),10,0);
               INSERT INTO ITEMEXPEDICAO
               (CDFILIAL, NREXPEDICAO, NRPEDIDO, CDTIPOOPER, IDATUESTTPOP, IDDESTINO, CDFILIALPED, CDCLIENTE, CDDESTINO, DTVALIPED,
                IDTPIJURTRAN, NRINSJURTRAN, CDTIPTRANS, IDPGFRETTRAN, NRPLACAVEPED,  SGUFVEICPED,
                CDEMPRESA,   CDINSCESTA,   CDINSCMUNI,   CDSERIE, IDPEDINDUSTRIA, CDVENDEDOR,
                CDMODPGTO , IDTPFORPGTPED , NRDIAPGFIXPED, NRPARCPGTOPED, IDUTDIAPAGPED, IDAGRUPAEXP, IDGERANFPEDI, CDQUEBRANF,
                NRITEMPED, CDPRODUTO, CDPRODMOVI, VRFATOCONV, IDCNTRESTOQ, IDSITITEMPED, CDPRODEMIS, DSPRODEMIS, VRPESOLIQ, VRPESOBRUTO,
                QTITEMEXP, QTMAXEXP, QTITEMPROD, QTITEMPED, QTEXPEDIDA, IDUTILALMOX, CDALMOXEXP, IDUTILLCESTQ, CDLOCALEXP,
                VRPRECOEXP, VRCUSTO, VRFATPRECO, VRDESITEXP, IDITEMPEDTERC, IDUTCTRLLOTE,
                IDRESERVA, QTRESERVADA, NRLOTEEXP, NRSUBLOTEEXP, NRSEQITEMEXP, IDERRO)
               VALUES
               (C_ITEM.CDFILIAL, P_NREXPEDICAO, C_ITEM.NRPEDIDO, V_CDTIPOOPER, V_IDATUESTTPOP, V_IDDESTINO, C_ITEM.CDFILIALPED, C_ITEM.CDCLIENTE, V_CDDESTINO,C_ITEM.DTVALIPED,
                C_ITEM.IDTPIJURTRAN, C_ITEM.NRINSJURTRAN, C_ITEM.CDTIPTRANS, C_ITEM.IDPGFRETTRAN, C_ITEM.NRPLACAVEPED,  C_ITEM.SGUFVEICPED,
                V_CDEMPRESA, V_CDINSCESTA, V_CDINSCMUNI, V_CDSERIE, C_ITEM.IDPEDINDUSTRIA, C_ITEM.CDVENDEDOR,
                C_ITEM.CDMODPGTO , C_ITEM.IDTPFORPGTPED , C_ITEM.NRDIAPGFIXPED, C_ITEM.NRPARCPGTOPED, C_ITEM.IDUTDIAPAGPED, V_IDAGRUPAEXP, V_IDGERANFPEDI, V_CDQUEBRANF,
                C_ITEM.NRITEMPED,  C_ITEM.CDPRODUTO, V_CDPRODMOVI, C_ITEM.VRFATOCONV, V_IDCNTRESTOQ, C_ITEM.IDSITITEMPED, C_ITEM.CDPRODEMIS, C_ITEM.DSPRODEMIS, V_VRPESOLIQEXP, V_VRPESOBRUTOEXP,
                C_ITEM.QTITEMEXP, V_QTMAXEXP, V_QTITEMPROD, C_ITEM.QTITEMPED, C_ITEM.QTEXPITEMPED, V_IDUTILALMOX, V_CDALMOXEXP, V_IDUTILLCESTQ, V_CDLOCALEXP,
                V_VRPRECO, V_VRCUSTO, V_VRFATPRECO, V_VRDESCEXP, C_ITEM.IDITEMPEDTERC, V_IDUTCTRLLOTE,
                'N', 0, NULL, NULL, V_NRSEQ, 'N');
            END IF;
         END LOOP;
      END IF;
   END LOOP;

   /*VALIDA ITENS SELECIONADOS*/

/*------------------'FILIAL_N_PARAM'--------------*/
   IF (V_PAREXP = 0) THEN
      UPDATE ITEMEXPEDICAO
         SET IDERRO = 'S'
       WHERE CDFILIAL = P_CDFILIAL
         AND NREXPEDICAO = P_NREXPEDICAO;

      FOR C_ERRO IN (SELECT CDFILIAL, NREXPEDICAO, NRPEDIDO, NRITEMPED, CDPRODUTO
                         FROM ITEMEXPEDICAO
                      WHERE CDFILIAL = P_CDFILIAL
                        AND NREXPEDICAO = P_NREXPEDICAO)
      LOOP

         SELECT NVL(MAX(NRSEQERROITEM),0)
           INTO V_NRSEQ
           FROM ERROITEMEXP
          WHERE CDFILIAL = C_ERRO.CDFILIAL
            AND NREXPEDICAO = C_ERRO.NREXPEDICAO
            AND NRPEDIDO = C_ERRO.NRPEDIDO;

         V_NRSEQ := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_NRSEQ) + 1)),10,0);
         V_ERRO := 0;
         SELECT COUNT(1)
           INTO V_ERRO
           FROM ERROITEMEXP
          WHERE CDFILIAL = C_ERRO.CDFILIAL
            AND NREXPEDICAO = C_ERRO.NREXPEDICAO
            AND NRPEDIDO = C_ERRO.NRPEDIDO
            AND DSERRO = 'FILIAL_N_PARAM';
         IF (V_ERRO = 0) THEN
            INSERT INTO ERROITEMEXP
            (CDFILIAL, NREXPEDICAO, NRPEDIDO, NRITEMPED, NRSEQERROITEM, DSERRO)
            VALUES
            (C_ERRO.CDFILIAL, C_ERRO.NREXPEDICAO, C_ERRO.NRPEDIDO, '', V_NRSEQ, 'FILIAL_N_PARAM');
         END IF;
      END LOOP;
   END IF;
/*------------------'FILIAL_N_PARAM'--------------*/

/*------------------'TPOPER_N_INF'--------------*/
   IF (V_IDOBRTPOPPED = 'S') THEN
      FOR C_ERRO IN (SELECT CDFILIAL, NREXPEDICAO, NRPEDIDO, NRITEMPED, CDPRODUTO
                       FROM ITEMEXPEDICAO
                      WHERE CDFILIAL = P_CDFILIAL
                        AND NREXPEDICAO = P_NREXPEDICAO
                        AND CDTIPOOPER IS NULL)
      LOOP
         UPDATE ITEMEXPEDICAO
            SET IDERRO = 'S'
          WHERE CDFILIAL = C_ERRO.CDFILIAL
            AND NREXPEDICAO = C_ERRO.NREXPEDICAO
            AND NRPEDIDO = C_ERRO.NRPEDIDO
            AND NRITEMPED = C_ERRO.NRITEMPED;

         SELECT NVL(MAX(NRSEQERROITEM),0)
           INTO V_NRSEQ
           FROM ERROITEMEXP
          WHERE CDFILIAL = C_ERRO.CDFILIAL
            AND NREXPEDICAO = C_ERRO.NREXPEDICAO
            AND NRPEDIDO = C_ERRO.NRPEDIDO;

         V_NRSEQ := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_NRSEQ) + 1)),10,0);

         V_ERRO := 0;
         SELECT COUNT(1)
           INTO V_ERRO
           FROM ERROITEMEXP
          WHERE CDFILIAL = C_ERRO.CDFILIAL
            AND NREXPEDICAO = C_ERRO.NREXPEDICAO
            AND NRPEDIDO = C_ERRO.NRPEDIDO
            AND DSERRO = 'TPOPER_N_INF';

         IF (V_ERRO = 0) THEN
            INSERT INTO ERROITEMEXP
            (CDFILIAL, NREXPEDICAO, NRPEDIDO, NRITEMPED, NRSEQERROITEM, DSERRO)
            VALUES
            (C_ERRO.CDFILIAL, C_ERRO.NREXPEDICAO, C_ERRO.NRPEDIDO, '', V_NRSEQ, 'TPOPER_N_INF');
         END IF;
      END LOOP;
   END IF;
/*------------------'TPOPER_N_INF'--------------*/

/*------------------'PEDNFILDEST'--------------*/
   FOR C_ERRO IN (SELECT CDFILIAL, NREXPEDICAO, NRPEDIDO, NRITEMPED, CDPRODUTO, CDFILIALPED
                    FROM ITEMEXPEDICAO
                   WHERE CDFILIAL = P_CDFILIAL
                     AND NREXPEDICAO = P_NREXPEDICAO
                     AND IDDESTINO = 'L'
                     AND CDFILIALPED IS NULL)
   LOOP
      UPDATE ITEMEXPEDICAO
         SET IDERRO = 'S'
       WHERE CDFILIAL = C_ERRO.CDFILIAL
         AND NREXPEDICAO = C_ERRO.NREXPEDICAO
         AND NRPEDIDO = C_ERRO.NRPEDIDO
         AND NRITEMPED = C_ERRO.NRITEMPED;

      SELECT NVL(MAX(NRSEQERROITEM),0)
        INTO V_NRSEQ
        FROM ERROITEMEXP
       WHERE CDFILIAL = C_ERRO.CDFILIAL
         AND NREXPEDICAO = C_ERRO.NREXPEDICAO
         AND NRPEDIDO = C_ERRO.NRPEDIDO;

      V_NRSEQ := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_NRSEQ) + 1)),10,0);

      V_ERRO := 0;
      SELECT COUNT(1)
        INTO V_ERRO
        FROM ERROITEMEXP
       WHERE CDFILIAL = C_ERRO.CDFILIAL
         AND NREXPEDICAO = C_ERRO.NREXPEDICAO
         AND NRPEDIDO = C_ERRO.NRPEDIDO
         AND DSERRO = 'PEDNFILDEST';
      IF (V_ERRO = 0) THEN
         INSERT INTO ERROITEMEXP
         (CDFILIAL, NREXPEDICAO, NRPEDIDO, NRITEMPED, NRSEQERROITEM, CDFILIALPED, DSERRO)
         VALUES
         (C_ERRO.CDFILIAL, C_ERRO.NREXPEDICAO, C_ERRO.NRPEDIDO, '', V_NRSEQ, C_ERRO.CDFILIALPED, 'PEDNFILDEST');
      END IF;
   END LOOP;
/*------------------'PEDNFILDEST'--------------*/

/*------------------'FILIDEST_INATIVA'--------------*/
   FOR C_ERRO IN (SELECT I.CDFILIAL, I.NREXPEDICAO, I.NRPEDIDO, I.CDFILIALPED, I.NRITEMPED, I.CDPRODUTO
                       FROM ITEMEXPEDICAO I JOIN FILIAL F
                                              ON I.CDFILIALPED = F.CDFILIAL
                      WHERE I.CDFILIAL = P_CDFILIAL
                        AND I.NREXPEDICAO = P_NREXPEDICAO
                        AND F.IDCNTRRESC = 'S')
   LOOP
      UPDATE ITEMEXPEDICAO
         SET IDERRO = 'S'
       WHERE CDFILIAL = C_ERRO.CDFILIAL
         AND NREXPEDICAO = C_ERRO.NREXPEDICAO
         AND NRPEDIDO = C_ERRO.NRPEDIDO
         AND NRITEMPED = C_ERRO.NRITEMPED;

      SELECT NVL(MAX(NRSEQERROITEM),0)
        INTO V_NRSEQ
        FROM ERROITEMEXP
       WHERE CDFILIAL = C_ERRO.CDFILIAL
         AND NREXPEDICAO = C_ERRO.NREXPEDICAO
         AND NRPEDIDO = C_ERRO.NRPEDIDO;

      V_NRSEQ := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_NRSEQ) + 1)),10,0);
      V_ERRO := 0;
      SELECT COUNT(1)
        INTO V_ERRO
        FROM ERROITEMEXP
       WHERE CDFILIAL = C_ERRO.CDFILIAL
         AND NREXPEDICAO = C_ERRO.NREXPEDICAO
         AND NRPEDIDO = C_ERRO.NRPEDIDO
         AND DSERRO = 'FILIDEST_INATIVA';

      IF (V_ERRO = 0) THEN
         INSERT INTO ERROITEMEXP
         (CDFILIAL, NREXPEDICAO, NRPEDIDO, NRITEMPED, NRSEQERROITEM, CDFILIALPED, DSERRO)
         VALUES
         (C_ERRO.CDFILIAL, C_ERRO.NREXPEDICAO, C_ERRO.NRPEDIDO, '', V_NRSEQ, C_ERRO.CDFILIALPED, 'FILIDEST_INATIVA');
      END IF;
   END LOOP;
/*------------------'FILIDEST_INATIVA'--------------*/

/*------------------'FRETE_NULO'--------------*/
   FOR C_ERRO IN (SELECT CDFILIAL, NREXPEDICAO, NRPEDIDO, NRITEMPED, CDPRODUTO
                           FROM ITEMEXPEDICAO
                          WHERE CDFILIAL = P_CDFILIAL
                            AND NREXPEDICAO = P_NREXPEDICAO
                            AND IDPGFRETTRAN IS NULL)
   LOOP
      UPDATE ITEMEXPEDICAO
         SET IDERRO = 'S'
       WHERE CDFILIAL = C_ERRO.CDFILIAL
         AND NREXPEDICAO = C_ERRO.NREXPEDICAO
         AND NRPEDIDO = C_ERRO.NRPEDIDO
         AND NRITEMPED = C_ERRO.NRITEMPED;

      SELECT NVL(MAX(NRSEQERROITEM),0)
        INTO V_NRSEQ
        FROM ERROITEMEXP
       WHERE CDFILIAL = C_ERRO.CDFILIAL
         AND NREXPEDICAO = C_ERRO.NREXPEDICAO
         AND NRPEDIDO = C_ERRO.NRPEDIDO;

      V_NRSEQ := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_NRSEQ) + 1)),10,0);
      V_ERRO := 0;
      SELECT COUNT(1)
        INTO V_ERRO
        FROM ERROITEMEXP
       WHERE CDFILIAL = C_ERRO.CDFILIAL
         AND NREXPEDICAO = C_ERRO.NREXPEDICAO
         AND NRPEDIDO = C_ERRO.NRPEDIDO
         AND DSERRO = 'FRETE_NULO';

      IF (V_ERRO = 0) THEN
         INSERT INTO ERROITEMEXP
         (CDFILIAL, NREXPEDICAO, NRPEDIDO, NRITEMPED, NRSEQERROITEM, DSERRO)
         VALUES
         (C_ERRO.CDFILIAL, C_ERRO.NREXPEDICAO, C_ERRO.NRPEDIDO, '', V_NRSEQ, 'FRETE_NULO');
      END IF;
   END LOOP;
/*------------------'FRETE_NULO'--------------*/

/*------------------'TRANSP_NULL'--------------*/
   FOR C_ERRO IN (SELECT CDFILIAL, NREXPEDICAO, NRPEDIDO, NRITEMPED, CDPRODUTO
                    FROM ITEMEXPEDICAO
                   WHERE CDFILIAL = P_CDFILIAL
                     AND NREXPEDICAO = P_NREXPEDICAO
                     AND IDPGFRETTRAN NOT IN ('9', '3')
                     AND ((IDTPIJURTRAN IS NULL) OR (NRINSJURTRAN IS NULL)))
   LOOP
      UPDATE ITEMEXPEDICAO
         SET IDERRO = 'S'
       WHERE CDFILIAL = C_ERRO.CDFILIAL
         AND NREXPEDICAO = C_ERRO.NREXPEDICAO
         AND NRPEDIDO = C_ERRO.NRPEDIDO
         AND NRITEMPED = C_ERRO.NRITEMPED;

      SELECT NVL(MAX(NRSEQERROITEM),0)
        INTO V_NRSEQ
        FROM ERROITEMEXP
       WHERE CDFILIAL = C_ERRO.CDFILIAL
         AND NREXPEDICAO = C_ERRO.NREXPEDICAO
         AND NRPEDIDO = C_ERRO.NRPEDIDO;

      V_NRSEQ := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_NRSEQ) + 1)),10,0);
      V_ERRO := 0;
      SELECT COUNT(1)
        INTO V_ERRO
        FROM ERROITEMEXP
       WHERE CDFILIAL = C_ERRO.CDFILIAL
         AND NREXPEDICAO = C_ERRO.NREXPEDICAO
         AND NRPEDIDO = C_ERRO.NRPEDIDO
         AND DSERRO = 'TRANSP_NULL';

      IF (V_ERRO = 0) THEN
         INSERT INTO ERROITEMEXP
         (CDFILIAL, NREXPEDICAO, NRPEDIDO, NRITEMPED, NRSEQERROITEM, DSERRO)
         VALUES
         (C_ERRO.CDFILIAL, C_ERRO.NREXPEDICAO, C_ERRO.NRPEDIDO, '', V_NRSEQ, 'TRANSP_NULL');
      END IF;
   END LOOP;
/*------------------'TRANSP_NULL'--------------*/

   IF (V_IDUTVALIPED = 'S') THEN
/*------------------'DTVAL_INF'--------------*/
      FOR C_ERRO IN (SELECT CDFILIAL, NREXPEDICAO, NRPEDIDO, NRITEMPED, CDPRODUTO
                       FROM ITEMEXPEDICAO
                      WHERE CDFILIAL = P_CDFILIAL
                        AND NREXPEDICAO = P_NREXPEDICAO
                        AND (DTVALIPED IS NULL))
      LOOP
         UPDATE ITEMEXPEDICAO
            SET IDERRO = 'S'
          WHERE CDFILIAL = C_ERRO.CDFILIAL
            AND NREXPEDICAO = C_ERRO.NREXPEDICAO
            AND NRPEDIDO = C_ERRO.NRPEDIDO
            AND NRITEMPED = C_ERRO.NRITEMPED;

         SELECT NVL(MAX(NRSEQERROITEM),0)
           INTO V_NRSEQ
           FROM ERROITEMEXP
          WHERE CDFILIAL = C_ERRO.CDFILIAL
            AND NREXPEDICAO = C_ERRO.NREXPEDICAO
            AND NRPEDIDO = C_ERRO.NRPEDIDO;

         V_NRSEQ := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_NRSEQ) + 1)),10,0);
         V_ERRO := 0;
         SELECT COUNT(1)
           INTO V_ERRO
           FROM ERROITEMEXP
          WHERE CDFILIAL = C_ERRO.CDFILIAL
            AND NREXPEDICAO = C_ERRO.NREXPEDICAO
            AND NRPEDIDO = C_ERRO.NRPEDIDO
            AND DSERRO = 'DTVAL_INF';

         IF (V_ERRO = 0) THEN
            INSERT INTO ERROITEMEXP
            (CDFILIAL, NREXPEDICAO, NRPEDIDO, NRITEMPED, NRSEQERROITEM, DSERRO)
            VALUES
            (C_ERRO.CDFILIAL, C_ERRO.NREXPEDICAO, C_ERRO.NRPEDIDO, '', V_NRSEQ, 'DTVAL_INF');
         END IF;
      END LOOP;
/*------------------'DTVAL_INF'--------------*/

/*------------------'DTVAL_INV'--------------*/
      FOR C_ERRO IN (SELECT CDFILIAL, NREXPEDICAO, NRPEDIDO, NRITEMPED, CDPRODUTO
                       FROM ITEMEXPEDICAO
                      WHERE CDFILIAL = P_CDFILIAL
                        AND NREXPEDICAO = P_NREXPEDICAO
                        AND (TRUNC(DTVALIPED) < TRUNC(SYSDATE)))
      LOOP
         UPDATE ITEMEXPEDICAO
            SET IDERRO = 'S'
          WHERE CDFILIAL = C_ERRO.CDFILIAL
            AND NREXPEDICAO = C_ERRO.NREXPEDICAO
            AND NRPEDIDO = C_ERRO.NRPEDIDO
            AND NRITEMPED = C_ERRO.NRITEMPED;

         SELECT NVL(MAX(NRSEQERROITEM),0)
           INTO V_NRSEQ
           FROM ERROITEMEXP
          WHERE CDFILIAL = C_ERRO.CDFILIAL
            AND NREXPEDICAO = C_ERRO.NREXPEDICAO
            AND NRPEDIDO = C_ERRO.NRPEDIDO;

         V_NRSEQ := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_NRSEQ) + 1)),10,0);
         V_ERRO := 0;
         SELECT COUNT(1)
           INTO V_ERRO
           FROM ERROITEMEXP
          WHERE CDFILIAL = C_ERRO.CDFILIAL
            AND NREXPEDICAO = C_ERRO.NREXPEDICAO
            AND NRPEDIDO = C_ERRO.NRPEDIDO
            AND DSERRO = 'DTVAL_INV';
         IF (V_ERRO = 0) THEN
            INSERT INTO ERROITEMEXP
            (CDFILIAL, NREXPEDICAO, NRPEDIDO, NRITEMPED, NRSEQERROITEM, DSERRO)
            VALUES
            (C_ERRO.CDFILIAL, C_ERRO.NREXPEDICAO, C_ERRO.NRPEDIDO, '', V_NRSEQ, 'DTVAL_INV');
         END IF;
      END LOOP;
/*------------------'DTVAL_INF'--------------*/
   END IF;

   IF (V_IDEMPRESANFEXP = 'EMPRESACLIENTE') THEN
/*------------------'SERIE_CLIENTE'--------------*/
      FOR C_ERRO IN (SELECT CDFILIAL, NREXPEDICAO, NRPEDIDO, CDCLIENTE, NRITEMPED, CDPRODUTO
                       FROM ITEMEXPEDICAO
                      WHERE CDFILIAL = P_CDFILIAL
                        AND NREXPEDICAO = P_NREXPEDICAO
                        AND ((CDEMPRESA IS NULL) OR (CDINSCESTA IS NULL) OR (CDINSCMUNI IS NULL) OR (CDSERIE IS NULL)))
      LOOP
         UPDATE ITEMEXPEDICAO
            SET IDERRO = 'S'
          WHERE CDFILIAL = C_ERRO.CDFILIAL
            AND NREXPEDICAO = C_ERRO.NREXPEDICAO
            AND NRPEDIDO = C_ERRO.NRPEDIDO
            AND NRITEMPED = C_ERRO.NRITEMPED;

         SELECT NVL(MAX(NRSEQERROITEM),0)
           INTO V_NRSEQ
           FROM ERROITEMEXP
          WHERE CDFILIAL = C_ERRO.CDFILIAL
            AND NREXPEDICAO = C_ERRO.NREXPEDICAO
            AND NRPEDIDO = C_ERRO.NRPEDIDO;

         V_NRSEQ := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_NRSEQ) + 1)),10,0);
         V_ERRO := 0;
         SELECT COUNT(1)
           INTO V_ERRO
           FROM ERROITEMEXP
          WHERE CDFILIAL = C_ERRO.CDFILIAL
            AND NREXPEDICAO = C_ERRO.NREXPEDICAO
            AND NRPEDIDO = C_ERRO.NRPEDIDO
            AND DSERRO = 'SERIE_CLIENTE';
         IF (V_ERRO = 0) THEN
            INSERT INTO ERROITEMEXP
            (CDFILIAL, NREXPEDICAO, NRPEDIDO, NRITEMPED, NRSEQERROITEM, CDCLIENTE, DSERRO)
            VALUES
            (C_ERRO.CDFILIAL, C_ERRO.NREXPEDICAO, C_ERRO.NRPEDIDO, '', V_NRSEQ, C_ERRO.CDCLIENTE, 'SERIE_CLIENTE');
         END IF;
      END LOOP;
/*------------------'SERIE_CLIENTE'--------------*/
   END IF;
/*------------------'PEDINDUSTRIA'--------------*/
   FOR C_ERRO IN (SELECT CDFILIAL, NREXPEDICAO, NRPEDIDO, CDCLIENTE, NRITEMPED
                    FROM ITEMEXPEDICAO
                   WHERE CDFILIAL = P_CDFILIAL
                     AND NREXPEDICAO = P_NREXPEDICAO
                     AND (IDPEDINDUSTRIA = 'S'))
   LOOP
      BEGIN
         SELECT MAX(IDTIPOEXP)
           INTO V_IDTIPOEXP
           FROM EXPRELACITEMPPED
          WHERE CDFILIAL = P_CDFILIAL
            AND NREXPEDICAO = P_NREXPEDICAO;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN BEGIN
            V_IDTIPOEXP := NULL;
         END;
      END;
      IF (V_IDTIPOEXP = 'ITEM') THEN
         UPDATE ITEMEXPEDICAO
            SET IDERRO = 'S'
          WHERE CDFILIAL = C_ERRO.CDFILIAL
            AND NREXPEDICAO = C_ERRO.NREXPEDICAO
            AND NRPEDIDO = C_ERRO.NRPEDIDO
            AND NRITEMPED = C_ERRO.NRITEMPED;

         SELECT NVL(MAX(NRSEQERROITEM),0)
           INTO V_NRSEQ
           FROM ERROITEMEXP
          WHERE CDFILIAL = C_ERRO.CDFILIAL
            AND NREXPEDICAO = C_ERRO.NREXPEDICAO
            AND NRPEDIDO = C_ERRO.NRPEDIDO;

         V_NRSEQ := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_NRSEQ) + 1)),10,0);
         V_ERRO := 0;
         SELECT COUNT(1)
           INTO V_ERRO
           FROM ERROITEMEXP
          WHERE CDFILIAL = C_ERRO.CDFILIAL
            AND NREXPEDICAO = C_ERRO.NREXPEDICAO
            AND NRPEDIDO = C_ERRO.NRPEDIDO
            AND DSERRO = 'PEDINDUSTRIA';
         IF (V_ERRO = 0) THEN
            INSERT INTO ERROITEMEXP
            (CDFILIAL, NREXPEDICAO, NRPEDIDO, NRITEMPED, NRSEQERROITEM, DSERRO)
            VALUES
            (C_ERRO.CDFILIAL, C_ERRO.NREXPEDICAO, C_ERRO.NRPEDIDO, '', V_NRSEQ, 'PEDINDUSTRIA');
         END IF;
      END IF;
   END LOOP;
/*------------------'PEDINDUSTRIA'--------------*/

   IF (V_IDCTRLESTQ = 'S') THEN
/*------------------'ALMOX_NULL'--------------*/
      FOR C_ERRO IN (SELECT CDFILIAL, NREXPEDICAO, NRPEDIDO, NRITEMPED, CDPRODUTO
                       FROM ITEMEXPEDICAO
                      WHERE CDFILIAL = P_CDFILIAL
                        AND NREXPEDICAO = P_NREXPEDICAO
                        AND CDTIPOOPER IS NOT NULL
                        AND IDATUESTTPOP = 'S'
                        AND IDCNTRESTOQ = 'S'
                        AND IDRESERVA = 'N'
                        AND ((V_IDUTILALMOX = 'S') AND (CDALMOXEXP IS NULL)))
      LOOP
         UPDATE ITEMEXPEDICAO
            SET IDERRO = 'S'
          WHERE CDFILIAL = C_ERRO.CDFILIAL
            AND NREXPEDICAO = C_ERRO.NREXPEDICAO
            AND NRPEDIDO = C_ERRO.NRPEDIDO
            AND NRITEMPED = C_ERRO.NRITEMPED;

         SELECT NVL(MAX(NRSEQERROITEM),0)
           INTO V_NRSEQ
           FROM ERROITEMEXP
          WHERE CDFILIAL = C_ERRO.CDFILIAL
            AND NREXPEDICAO = C_ERRO.NREXPEDICAO
            AND NRPEDIDO = C_ERRO.NRPEDIDO;

         V_NRSEQ := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_NRSEQ) + 1)),10,0);

         INSERT INTO ERROITEMEXP
         (CDFILIAL, NREXPEDICAO, NRPEDIDO, NRITEMPED, NRSEQERROITEM, CDPRODUTO, DSERRO)
         VALUES
         (C_ERRO.CDFILIAL, C_ERRO.NREXPEDICAO, C_ERRO.NRPEDIDO, C_ERRO.NRITEMPED, V_NRSEQ, C_ERRO.CDPRODUTO, 'ALMOX_NULL');
      END LOOP;
/*------------------'ALMOX_NULL'--------------*/

/*------------------'LOCAL_NULL'--------------*/
      FOR C_ERRO IN (SELECT CDFILIAL, NREXPEDICAO, NRPEDIDO, NRITEMPED, CDPRODUTO
                       FROM ITEMEXPEDICAO
                      WHERE CDFILIAL = P_CDFILIAL
                        AND NREXPEDICAO = P_NREXPEDICAO
                        AND CDTIPOOPER IS NOT NULL
                        AND IDATUESTTPOP = 'S'
                        AND IDCNTRESTOQ = 'S'
                        AND IDRESERVA = 'N'
                        AND ((V_IDUTILLCESTQ  = 'S') AND (CDLOCALEXP IS NULL)))
      LOOP
         UPDATE ITEMEXPEDICAO
            SET IDERRO = 'S'
          WHERE CDFILIAL = C_ERRO.CDFILIAL
            AND NREXPEDICAO = C_ERRO.NREXPEDICAO
            AND NRPEDIDO = C_ERRO.NRPEDIDO
            AND NRITEMPED = C_ERRO.NRITEMPED;

         SELECT NVL(MAX(NRSEQERROITEM),0)
           INTO V_NRSEQ
           FROM ERROITEMEXP
          WHERE CDFILIAL = C_ERRO.CDFILIAL
            AND NREXPEDICAO = C_ERRO.NREXPEDICAO
            AND NRPEDIDO = C_ERRO.NRPEDIDO;

         V_NRSEQ := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_NRSEQ) + 1)),10,0);
         INSERT INTO ERROITEMEXP
         (CDFILIAL, NREXPEDICAO, NRPEDIDO, NRITEMPED, NRSEQERROITEM, CDPRODUTO, DSERRO)
         VALUES
         (C_ERRO.CDFILIAL, C_ERRO.NREXPEDICAO, C_ERRO.NRPEDIDO, C_ERRO.NRITEMPED, V_NRSEQ, C_ERRO.CDPRODUTO, 'LOCAL_NULL');
      END LOOP;
/*------------------'LOCAL_NULL'--------------*/
   END IF;


/*------------------'PRECO_PROD'--------------*/
   FOR C_ERRO IN (SELECT CDFILIAL, NREXPEDICAO, NRPEDIDO, NRITEMPED, CDPRODUTO
                    FROM ITEMEXPEDICAO
                   WHERE CDFILIAL = P_CDFILIAL
                     AND NREXPEDICAO = P_NREXPEDICAO
                     AND VRPRECOEXP <= 0)
   LOOP
      UPDATE ITEMEXPEDICAO
         SET IDERRO = 'S'
       WHERE CDFILIAL = C_ERRO.CDFILIAL
         AND NREXPEDICAO = C_ERRO.NREXPEDICAO
         AND NRPEDIDO = C_ERRO.NRPEDIDO
         AND NRITEMPED = C_ERRO.NRITEMPED;

      SELECT NVL(MAX(NRSEQERROITEM),0)
        INTO V_NRSEQ
        FROM ERROITEMEXP
       WHERE CDFILIAL = C_ERRO.CDFILIAL
         AND NREXPEDICAO = C_ERRO.NREXPEDICAO
         AND NRPEDIDO = C_ERRO.NRPEDIDO;

      V_NRSEQ := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_NRSEQ) + 1)),10,0);
      V_ERRO := 0;
      SELECT COUNT(1)
        INTO V_ERRO
        FROM ERROITEMEXP
       WHERE CDFILIAL = C_ERRO.CDFILIAL
         AND NREXPEDICAO = C_ERRO.NREXPEDICAO
         AND NRPEDIDO = C_ERRO.NRPEDIDO
         AND NRITEMPED = C_ERRO.NRITEMPED
         AND DSERRO = 'PRECO_PROD';
      IF (V_ERRO = 0) THEN
         INSERT INTO ERROITEMEXP
         (CDFILIAL, NREXPEDICAO, NRPEDIDO, NRITEMPED, NRSEQERROITEM, CDPRODUTO, DSERRO)
         VALUES
         (C_ERRO.CDFILIAL, C_ERRO.NREXPEDICAO, C_ERRO.NRPEDIDO, C_ERRO.NRITEMPED, V_NRSEQ, C_ERRO.CDPRODUTO, 'PRECO_PROD');
      END IF;
   END LOOP;
/*------------------'PRECO_PROD'--------------*/

   IF ((V_IDTABPRECO = '2') AND (V_IDCALCPRECFAT = 'E')) THEN
/*------------------'CUSTO_PROD'--------------*/
      FOR C_ERRO IN (SELECT CDFILIAL, NREXPEDICAO, NRPEDIDO, NRITEMPED, CDPRODUTO
                       FROM ITEMEXPEDICAO
                      WHERE CDFILIAL = P_CDFILIAL
                        AND NREXPEDICAO = P_NREXPEDICAO
                        AND VRCUSTO <= 0)
      LOOP
         UPDATE ITEMEXPEDICAO
            SET IDERRO = 'S'
          WHERE CDFILIAL = C_ERRO.CDFILIAL
            AND NREXPEDICAO = C_ERRO.NREXPEDICAO
            AND NRPEDIDO = C_ERRO.NRPEDIDO
            AND NRITEMPED = C_ERRO.NRITEMPED;

         SELECT NVL(MAX(NRSEQERROITEM),0)
           INTO V_NRSEQ
           FROM ERROITEMEXP
          WHERE CDFILIAL = C_ERRO.CDFILIAL
            AND NREXPEDICAO = C_ERRO.NREXPEDICAO
            AND NRPEDIDO = C_ERRO.NRPEDIDO;

         V_NRSEQ := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_NRSEQ) + 1)),10,0);
         V_ERRO := 0;
         SELECT COUNT(1)
           INTO V_ERRO
           FROM ERROITEMEXP
          WHERE CDFILIAL = C_ERRO.CDFILIAL
            AND NREXPEDICAO = C_ERRO.NREXPEDICAO
            AND NRPEDIDO = C_ERRO.NRPEDIDO
            AND NRITEMPED = C_ERRO.NRITEMPED
            AND DSERRO = 'CUSTO_PROD';
         IF (V_ERRO = 0) THEN
            INSERT INTO ERROITEMEXP
            (CDFILIAL, NREXPEDICAO, NRPEDIDO, NRITEMPED, NRSEQERROITEM, CDPRODUTO, DSERRO)
            VALUES
            (C_ERRO.CDFILIAL, C_ERRO.NREXPEDICAO, C_ERRO.NRPEDIDO, C_ERRO.NRITEMPED, V_NRSEQ, C_ERRO.CDPRODUTO, 'CUSTO_PROD');
         END IF;
      END LOOP;
/*------------------'CUSTO_PROD'--------------*/

/*------------------'VRFATPRECO'--------------*/
      FOR C_ERRO IN (SELECT CDFILIAL, NREXPEDICAO, NRPEDIDO, NRITEMPED, CDPRODUTO
                            FROM ITEMEXPEDICAO
                           WHERE CDFILIAL = P_CDFILIAL
                             AND NREXPEDICAO = P_NREXPEDICAO
                             AND VRFATPRECO <= 0)
      LOOP
         UPDATE ITEMEXPEDICAO
            SET IDERRO = 'S'
          WHERE CDFILIAL = C_ERRO.CDFILIAL
            AND NREXPEDICAO = C_ERRO.NREXPEDICAO
            AND NRPEDIDO = C_ERRO.NRPEDIDO
            AND NRITEMPED = C_ERRO.NRITEMPED;

         SELECT NVL(MAX(NRSEQERROITEM),0)
           INTO V_NRSEQ
           FROM ERROITEMEXP
          WHERE CDFILIAL = C_ERRO.CDFILIAL
            AND NREXPEDICAO = C_ERRO.NREXPEDICAO
            AND NRPEDIDO = C_ERRO.NRPEDIDO;

         V_NRSEQ := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_NRSEQ) + 1)),10,0);
         V_ERRO := 0;
         SELECT COUNT(1)
           INTO V_ERRO
           FROM ERROITEMEXP
          WHERE CDFILIAL = C_ERRO.CDFILIAL
            AND NREXPEDICAO = C_ERRO.NREXPEDICAO
            AND NRPEDIDO = C_ERRO.NRPEDIDO
            AND NRITEMPED = C_ERRO.NRITEMPED
            AND DSERRO = 'VRFATPRECO';
         IF (V_ERRO = 0) THEN
            INSERT INTO ERROITEMEXP
            (CDFILIAL, NREXPEDICAO, NRPEDIDO, NRITEMPED, NRSEQERROITEM, CDPRODUTO, DSERRO)
            VALUES
            (C_ERRO.CDFILIAL, C_ERRO.NREXPEDICAO, C_ERRO.NRPEDIDO, C_ERRO.NRITEMPED, V_NRSEQ, C_ERRO.CDPRODUTO, 'VRFATPRECO');
         END IF;
      END LOOP;
/*------------------'VRFATPRECO'--------------*/
   END IF;

/*------------------'QTDEAEXP'--------------*/
   FOR C_ERRO IN (SELECT CDFILIAL, NREXPEDICAO, NRPEDIDO, NRITEMPED, CDPRODUTO, QTITEMEXP
                    FROM ITEMEXPEDICAO
                   WHERE CDFILIAL = P_CDFILIAL
                     AND NREXPEDICAO = P_NREXPEDICAO
                     AND QTITEMEXP < 0.001)
   LOOP
      UPDATE ITEMEXPEDICAO
         SET IDERRO = 'S'
       WHERE CDFILIAL = C_ERRO.CDFILIAL
         AND NREXPEDICAO = C_ERRO.NREXPEDICAO
         AND NRPEDIDO = C_ERRO.NRPEDIDO
         AND NRITEMPED = C_ERRO.NRITEMPED;

      SELECT NVL(MAX(NRSEQERROITEM),0)
        INTO V_NRSEQ
        FROM ERROITEMEXP
       WHERE CDFILIAL = C_ERRO.CDFILIAL
         AND NREXPEDICAO = C_ERRO.NREXPEDICAO
         AND NRPEDIDO = C_ERRO.NRPEDIDO;

      V_NRSEQ := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_NRSEQ) + 1)),10,0);
      V_ERRO := 0;
      SELECT COUNT(1)
        INTO V_ERRO
        FROM ERROITEMEXP
       WHERE CDFILIAL = C_ERRO.CDFILIAL
         AND NREXPEDICAO = C_ERRO.NREXPEDICAO
         AND NRPEDIDO = C_ERRO.NRPEDIDO
         AND NRITEMPED = C_ERRO.NRITEMPED
         AND DSERRO = 'QTDEAEXP';
      IF (V_ERRO = 0) THEN
         INSERT INTO ERROITEMEXP
         (CDFILIAL, NREXPEDICAO, NRPEDIDO, NRITEMPED, NRSEQERROITEM, CDPRODUTO, QTITEMEXP, DSERRO)
         VALUES
         (C_ERRO.CDFILIAL, C_ERRO.NREXPEDICAO, C_ERRO.NRPEDIDO, C_ERRO.NRITEMPED, V_NRSEQ, C_ERRO.CDPRODUTO, C_ERRO.QTITEMEXP, 'QTDEAEXP');
      END IF;
   END LOOP;
/*------------------'QTDEAEXP'--------------*/

/*------------------'QTMAXEXP'--------------*/
   FOR C_ERRO IN (SELECT CDFILIAL, NREXPEDICAO, NRPEDIDO, NRITEMPED, CDPRODUTO, QTITEMEXP
                    FROM ITEMEXPEDICAO
                   WHERE CDFILIAL = P_CDFILIAL
                     AND NREXPEDICAO = P_NREXPEDICAO
                     AND QTITEMEXP > QTMAXEXP)
   LOOP
      UPDATE ITEMEXPEDICAO
         SET IDERRO = 'S'
       WHERE CDFILIAL = C_ERRO.CDFILIAL
         AND NREXPEDICAO = C_ERRO.NREXPEDICAO
         AND NRPEDIDO = C_ERRO.NRPEDIDO
         AND NRITEMPED = C_ERRO.NRITEMPED;

      SELECT NVL(MAX(NRSEQERROITEM),0)
        INTO V_NRSEQ
        FROM ERROITEMEXP
       WHERE CDFILIAL = C_ERRO.CDFILIAL
         AND NREXPEDICAO = C_ERRO.NREXPEDICAO
         AND NRPEDIDO = C_ERRO.NRPEDIDO;

      V_NRSEQ := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_NRSEQ) + 1)),10,0);
      V_ERRO := 0;
      SELECT COUNT(1)
        INTO V_ERRO
        FROM ERROITEMEXP
       WHERE CDFILIAL = C_ERRO.CDFILIAL
         AND NREXPEDICAO = C_ERRO.NREXPEDICAO
         AND NRPEDIDO = C_ERRO.NRPEDIDO
         AND NRITEMPED = C_ERRO.NRITEMPED
         AND DSERRO = 'QTMAXEXP';
      IF (V_ERRO = 0) THEN
         INSERT INTO ERROITEMEXP
         (CDFILIAL, NREXPEDICAO, NRPEDIDO, NRITEMPED, NRSEQERROITEM, CDPRODUTO, QTITEMEXP, DSERRO)
         VALUES
         (C_ERRO.CDFILIAL, C_ERRO.NREXPEDICAO, C_ERRO.NRPEDIDO, C_ERRO.NRITEMPED, V_NRSEQ, C_ERRO.CDPRODUTO, C_ERRO.QTITEMEXP, 'QTMAXEXP');
      END IF;
   END LOOP;
/*------------------'QTMAXEXP'--------------*/

/*------------------'ITEMALTERADO'--------------*/
   FOR C_ERRO IN (SELECT IE.CDFILIAL, IE.NREXPEDICAO, IE.NRPEDIDO, IE.NRITEMPED, IE.CDPRODUTO
                    FROM ITEMEXPEDICAO IE JOIN ITEMPEDIDO IP
                                            ON IE.CDFILIAL = IP.CDFILIAL
                                           AND IE.NRPEDIDO = IP.NRPEDIDO
                                           AND IE.NRITEMPED = IP.NRITEMPED
                   WHERE IE.CDFILIAL = P_CDFILIAL
                     AND IE.NREXPEDICAO = P_NREXPEDICAO
                     AND ((IE.IDSITITEMPED <> IP.IDSITITEMPED) OR (IE.QTEXPEDIDA > IP.QTEXPITEMPED)))
   LOOP
      UPDATE ITEMEXPEDICAO
         SET IDERRO = 'S'
       WHERE CDFILIAL = C_ERRO.CDFILIAL
         AND NREXPEDICAO = C_ERRO.NREXPEDICAO
         AND NRPEDIDO = C_ERRO.NRPEDIDO
         AND NRITEMPED = C_ERRO.NRITEMPED;

      SELECT NVL(MAX(NRSEQERROITEM),0)
        INTO V_NRSEQ
        FROM ERROITEMEXP
       WHERE CDFILIAL = C_ERRO.CDFILIAL
         AND NREXPEDICAO = C_ERRO.NREXPEDICAO
         AND NRPEDIDO = C_ERRO.NRPEDIDO;

      V_NRSEQ := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_NRSEQ) + 1)),10,0);
      V_ERRO := 0;
      SELECT COUNT(1)
        INTO V_ERRO
        FROM ERROITEMEXP
       WHERE CDFILIAL = C_ERRO.CDFILIAL
         AND NREXPEDICAO = C_ERRO.NREXPEDICAO
         AND NRPEDIDO = C_ERRO.NRPEDIDO
         AND NRITEMPED = C_ERRO.NRITEMPED
         AND DSERRO = 'ITEMALTERADO';
      IF (V_ERRO = 0) THEN
         INSERT INTO ERROITEMEXP
         (CDFILIAL, NREXPEDICAO, NRPEDIDO, NRITEMPED, NRSEQERROITEM, CDPRODUTO, DSERRO)
         VALUES
         (C_ERRO.CDFILIAL, C_ERRO.NREXPEDICAO, C_ERRO.NRPEDIDO, C_ERRO.NRITEMPED, V_NRSEQ, C_ERRO.CDPRODUTO, 'ITEMALTERADO');
      END IF;
   END LOOP;
/*------------------'ITEMALTERADO'--------------*/


/*------------------'RESERVA_DIF'--------------*/
   FOR C_ERRO IN (SELECT CDFILIAL, NREXPEDICAO, NRPEDIDO, NRITEMPED, CDPRODUTO, (QTITEMEXP*VRFATOCONV) QTITEMEXPEST
                    FROM ITEMEXPEDICAO
                   WHERE CDFILIAL = P_CDFILIAL
                     AND NREXPEDICAO = P_NREXPEDICAO
                     AND IDRESERVA = 'S'

                  GROUP BY CDFILIAL, NREXPEDICAO, NRPEDIDO, NRITEMPED, CDPRODUTO, (QTITEMEXP*VRFATOCONV))
   LOOP
      BEGIN
         SELECT NVL(SUM(QTRESERVADA), 0)
           INTO V_QTRESERVTOT
           FROM ITEMEXPEDICAO
          WHERE CDFILIAL = P_CDFILIAL
            AND NREXPEDICAO = P_NREXPEDICAO
            AND NRPEDIDO = C_ERRO.NRPEDIDO
            AND NRITEMPED = C_ERRO.NRITEMPED
            AND IDRESERVA = 'S'
            AND NRLOTEEXP IS NOT NULL;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN BEGIN
            V_QTRESERVTOT := 0;
         END;
      END;

      IF (ROUND(C_ERRO.QTITEMEXPEST,5) <> ROUND(V_QTRESERVTOT,5)) THEN
         UPDATE ITEMEXPEDICAO
            SET IDERRO = 'S'
          WHERE CDFILIAL = C_ERRO.CDFILIAL
            AND NREXPEDICAO = C_ERRO.NREXPEDICAO
            AND NRPEDIDO = C_ERRO.NRPEDIDO
            AND NRITEMPED = C_ERRO.NRITEMPED;

         SELECT NVL(MAX(NRSEQERROITEM),0)
           INTO V_NRSEQ
           FROM ERROITEMEXP
          WHERE CDFILIAL = C_ERRO.CDFILIAL
            AND NREXPEDICAO = C_ERRO.NREXPEDICAO
            AND NRPEDIDO = C_ERRO.NRPEDIDO;

         V_NRSEQ := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_NRSEQ) + 1)),10,0);
         V_ERRO := 0;
         SELECT COUNT(1)
           INTO V_ERRO
           FROM ERROITEMEXP
          WHERE CDFILIAL = C_ERRO.CDFILIAL
            AND NREXPEDICAO = C_ERRO.NREXPEDICAO
            AND NRPEDIDO = C_ERRO.NRPEDIDO
            AND NRITEMPED = C_ERRO.NRITEMPED
            AND DSERRO = 'RESERVA_DIF';
         IF (V_ERRO = 0) THEN
            INSERT INTO ERROITEMEXP
            (CDFILIAL, NREXPEDICAO, NRPEDIDO, NRITEMPED, NRSEQERROITEM, CDPRODUTO, DSERRO)
            VALUES
            (C_ERRO.CDFILIAL, C_ERRO.NREXPEDICAO, C_ERRO.NRPEDIDO, C_ERRO.NRITEMPED, V_NRSEQ, C_ERRO.CDPRODUTO, 'RESERVA_DIF');
         END IF;
      END IF;
   END LOOP;
/*------------------'RESERVA_DIF'--------------*/

/*------------------'ITEMSESTOQ'--------------*/
   V_QTEXPEDIDA := 0;
   FOR C_ERRO IN (SELECT I.CDFILIAL, I.NREXPEDICAO, I.CDPRODMOVI, P.CDPRODESTO, P.VRFATOCONV, I.IDUTCTRLLOTE, I.IDUTILALMOX,
                         I.CDALMOXEXP, I.CDLOCALEXP, SUM(I.QTITEMPROD) AS QTEXPEDIDA
                    FROM ITEMEXPEDICAO I JOIN PRODUTO P
                                           ON I.CDPRODMOVI = P.CDPRODUTO
                   WHERE I.CDFILIAL = P_CDFILIAL
                     AND I.NREXPEDICAO = P_NREXPEDICAO
                     AND I.IDRESERVA = 'N'
                  GROUP BY I.CDFILIAL, I.NREXPEDICAO, I.CDPRODMOVI, P.CDPRODESTO, P.VRFATOCONV, I.IDUTCTRLLOTE, I.IDUTILALMOX, I.CDALMOXEXP, I.CDLOCALEXP)
   LOOP
      V_QTEXPEDIDA := C_ERRO.QTEXPEDIDA * C_ERRO.VRFATOCONV;
      V_TOTALESTOQUE := 0;
      FOR C_ESTOQ IN (SELECT P.CDFILIAL, P.CDALMOXARIFE, P.CDLOCALESTOQ, SUM(P.QTTOTALESTOQ) AS QTTOTALESTOQ
                        FROM POSESTATU P LEFT JOIN LOTE L
                                                ON P.CDFILIAL = L.CDFILIAL
                                               AND P.CDPRODUTO = L.CDPRODUTO
                                               AND P.NRLOTEESTQ = L.NRLOTEESTQ
                                               AND P.NRSUBLOTE = L.NRSUBLOTE
                                         JOIN LOCALESTOQUE LE
                                           ON P.CDFILIAL = LE.CDFILIAL
                                          AND P.CDALMOXARIFE = LE.CDALMOXARIFE
                                          AND P.CDLOCALESTOQ = LE.CDLOCALESTOQ
                       WHERE P.CDFILIAL = C_ERRO.CDFILIAL
                         AND P.CDPRODUTO = C_ERRO.CDPRODMOVI
                         AND P.CDALMOXARIFE = C_ERRO.CDALMOXEXP
                         AND P.CDLOCALESTOQ = C_ERRO.CDLOCALEXP
                         AND ((C_ERRO.IDUTCTRLLOTE = 'S') AND (TRUNC(L.DTVALILOTE) >= TRUNC(SYSDATE)) OR ((C_ERRO.IDUTCTRLLOTE = 'N')))
                         AND ((C_ERRO.IDUTILALMOX = 'N') OR (LE.IDDISPCONPED = 'S'))
                      GROUP BY P.CDFILIAL, P.CDALMOXARIFE, P.CDLOCALESTOQ)
      LOOP
         V_TOTALESTOQUE := V_TOTALESTOQUE + C_ESTOQ.QTTOTALESTOQ;
      END LOOP;
      IF (ROUND(V_QTEXPEDIDA, 5) > ROUND(V_TOTALESTOQUE, 5)) THEN

         FOR C_ITEMPEDSESTOQ IN (SELECT CDFILIAL, NREXPEDICAO, NRPEDIDO, NRITEMPED, CDPRODUTO, QTITEMEXP
                                   FROM ITEMEXPEDICAO
                                  WHERE CDFILIAL = C_ERRO.CDFILIAL
                                    AND NREXPEDICAO = C_ERRO.NREXPEDICAO
                                    AND CDPRODMOVI = C_ERRO.CDPRODMOVI)
         LOOP
            UPDATE ITEMEXPEDICAO
               SET IDERRO = 'S'
             WHERE CDFILIAL = C_ITEMPEDSESTOQ.CDFILIAL
               AND NREXPEDICAO = C_ITEMPEDSESTOQ.NREXPEDICAO
               AND NRPEDIDO = C_ITEMPEDSESTOQ.NRPEDIDO
               AND NRITEMPED = C_ITEMPEDSESTOQ.NRITEMPED;


            SELECT NVL(MAX(NRSEQERROITEM),0)
              INTO V_NRSEQ
              FROM ERROITEMEXP
             WHERE CDFILIAL = C_ITEMPEDSESTOQ.CDFILIAL
               AND NREXPEDICAO = C_ITEMPEDSESTOQ.NREXPEDICAO
               AND NRPEDIDO = C_ITEMPEDSESTOQ.NRPEDIDO;

            V_NRSEQ := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_NRSEQ) + 1)),10,0);
            V_ERRO := 0;
            SELECT COUNT(1)
              INTO V_ERRO
              FROM ERROITEMEXP
             WHERE CDFILIAL = C_ITEMPEDSESTOQ.CDFILIAL
               AND NREXPEDICAO = C_ITEMPEDSESTOQ.NREXPEDICAO
               AND NRPEDIDO = C_ITEMPEDSESTOQ.NRPEDIDO
               AND NRITEMPED = C_ITEMPEDSESTOQ.NRITEMPED
               AND DSERRO = 'ITEMSESTOQ';
            IF (V_ERRO = 0) THEN
               INSERT INTO ERROITEMEXP
               (CDFILIAL, NREXPEDICAO, NRPEDIDO, NRITEMPED, NRSEQERROITEM, CDPRODUTO, QTITEMEXP, QTTOTAITEMPROD, QTTOTAESTOQ, DSERRO)
               VALUES
               (C_ITEMPEDSESTOQ.CDFILIAL, C_ITEMPEDSESTOQ.NREXPEDICAO, C_ITEMPEDSESTOQ.NRPEDIDO, C_ITEMPEDSESTOQ.NRITEMPED, V_NRSEQ, C_ITEMPEDSESTOQ.CDPRODUTO, C_ITEMPEDSESTOQ.QTITEMEXP, V_QTEXPEDIDA, V_TOTALESTOQUE, 'ITEMSESTOQ');
            END IF;
         END LOOP;
      END IF;
   END LOOP;
/*------------------'ITEMSESTOQ'--------------*/

   IF (V_IDGERAREPLIC = '2') THEN
      FOR C_ERRO IN (SELECT I.CDFILIAL, I.NREXPEDICAO, I.NRPEDIDO, I.NRITEMPED, I.CDFILIALPED, I.CDPRODUTO, P.CDPRODESTO
                       FROM ITEMEXPEDICAO I JOIN PRODUTO P
                                              ON I.CDPRODMOVI = P.CDPRODUTO
                      WHERE I.CDFILIAL = P_CDFILIAL
                        AND I.NREXPEDICAO = P_NREXPEDICAO
                        AND I.CDFILIALPED IS NOT NULL)
      LOOP
/*------------------'SERIEENTR'--------------*/
         IF (P_CDSERIEENTR IS NULL) THEN
            UPDATE ITEMEXPEDICAO
               SET IDERRO = 'S'
             WHERE CDFILIAL = C_ERRO.CDFILIAL
               AND NREXPEDICAO = C_ERRO.NREXPEDICAO
               AND NRPEDIDO = C_ERRO.NRPEDIDO
               AND NRITEMPED = C_ERRO.NRITEMPED;

            SELECT NVL(MAX(NRSEQERROITEM),0)
              INTO V_NRSEQ
              FROM ERROITEMEXP
             WHERE CDFILIAL = C_ERRO.CDFILIAL
               AND NREXPEDICAO = C_ERRO.NREXPEDICAO
               AND NRPEDIDO = C_ERRO.NRPEDIDO;

            V_NRSEQ := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_NRSEQ) + 1)),10,0);
            V_ERRO := 0;
            SELECT COUNT(1)
              INTO V_ERRO
              FROM ERROITEMEXP
             WHERE CDFILIAL = C_ERRO.CDFILIAL
               AND NREXPEDICAO = C_ERRO.NREXPEDICAO
               AND NRPEDIDO = C_ERRO.NRPEDIDO
               AND DSERRO = 'SERIEENTR';
            IF (V_ERRO = 0) THEN
               INSERT INTO ERROITEMEXP
               (CDFILIAL, NREXPEDICAO, NRPEDIDO, NRITEMPED, NRSEQERROITEM, CDFILIALPED, CDPRODUTO, DSERRO)
               VALUES
               (C_ERRO.CDFILIAL, C_ERRO.NREXPEDICAO, C_ERRO.NRPEDIDO, '', V_NRSEQ, C_ERRO.CDFILIALPED, '', 'SERIEENTR');
            END IF;
         END IF;
/*------------------'SERIEENTR'--------------*/

/*------------------'TIPOOPERENTR'--------------*/
   		IF (P_CDTPOPERENTR IS NULL) THEN
			   UPDATE ITEMEXPEDICAO
               SET IDERRO = 'S'
             WHERE CDFILIAL = C_ERRO.CDFILIAL
               AND NREXPEDICAO = C_ERRO.NREXPEDICAO
               AND NRPEDIDO = C_ERRO.NRPEDIDO
               AND NRITEMPED = C_ERRO.NRITEMPED;

            SELECT NVL(MAX(NRSEQERROITEM),0)
              INTO V_NRSEQ
              FROM ERROITEMEXP
             WHERE CDFILIAL = C_ERRO.CDFILIAL
               AND NREXPEDICAO = C_ERRO.NREXPEDICAO
               AND NRPEDIDO = C_ERRO.NRPEDIDO;

            V_NRSEQ := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_NRSEQ) + 1)),10,0);
            V_ERRO := 0;
            SELECT COUNT(1)
              INTO V_ERRO
              FROM ERROITEMEXP
             WHERE CDFILIAL = C_ERRO.CDFILIAL
               AND NREXPEDICAO = C_ERRO.NREXPEDICAO
               AND NRPEDIDO = C_ERRO.NRPEDIDO
               AND DSERRO = 'TIPOOPERENTR';
            IF (V_ERRO = 0) THEN
               INSERT INTO ERROITEMEXP
               (CDFILIAL, NREXPEDICAO, NRPEDIDO, NRITEMPED, NRSEQERROITEM, CDFILIALPED, CDPRODUTO, DSERRO)
               VALUES
               (C_ERRO.CDFILIAL, C_ERRO.NREXPEDICAO, C_ERRO.NRPEDIDO, '', V_NRSEQ, C_ERRO.CDFILIALPED, '', 'TIPOOPERENTR');
            END IF;
	   	END IF;
/*------------------'TIPOOPERENTR'--------------*/

/*------------------'ALMOXENTR'--------------*/
         BEGIN
            SELECT IDUTILALMOX,   IDUTILLCESTQ,   IDUTILLOTE,   CDALMOXARIFE,   CDLOCALESTOQ,   DSNUMELOTE,   DSSEQULOTE
              INTO V_IDUTILALMOX, V_IDUTILLCESTQ, V_IDUTILLOTE, V_CDALMOXARIFE, V_CDLOCALESTOQ, V_DSNUMELOTE, V_DSSEQULOTE
              FROM PARAMFILIAL
             WHERE CDFILIAL = C_ERRO.CDFILIALPED;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN BEGIN
               V_IDUTILALMOX  := 'N';
               V_IDUTILLCESTQ := 'N';
               V_IDUTILLOTE   := 'N';
               V_CDALMOXARIFE := NULL;
               V_CDLOCALESTOQ := NULL;
               V_DSNUMELOTE   := NULL;
               V_DSSEQULOTE   := NULL;
            END;
         END;
         IF (V_IDUTILALMOX = 'S') THEN
            BEGIN
               SELECT CDALMOXPRCLI,   CDLOCALPRCLI
                 INTO V_CDALMOXPRCLI, V_CDLOCALPRCLI
                 FROM PRODFILI PF
                WHERE PF.CDPRODUTO = C_ERRO.CDPRODESTO
                  AND PF.CDFILIAL  = C_ERRO.CDFILIALPED;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_CDALMOXPRCLI := NULL;
                  V_CDLOCALPRCLI := NULL;
            END;
            IF (V_CDALMOXPRCLI IS NULL) THEN
               IF (V_CDALMOXARIFE IS NULL) THEN
                  UPDATE ITEMEXPEDICAO
                     SET IDERRO = 'S'
                   WHERE CDFILIAL = C_ERRO.CDFILIAL
                     AND NREXPEDICAO = C_ERRO.NREXPEDICAO
                     AND NRPEDIDO = C_ERRO.NRPEDIDO
                     AND NRITEMPED = C_ERRO.NRITEMPED;

                  SELECT NVL(MAX(NRSEQERROITEM),0)
                    INTO V_NRSEQ
                    FROM ERROITEMEXP
                   WHERE CDFILIAL = C_ERRO.CDFILIAL
                     AND NREXPEDICAO = C_ERRO.NREXPEDICAO
                     AND NRPEDIDO = C_ERRO.NRPEDIDO;

                  V_NRSEQ := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_NRSEQ) + 1)),10,0);
                  V_ERRO := 0;
                  SELECT COUNT(1)
                    INTO V_ERRO
                    FROM ERROITEMEXP
                   WHERE CDFILIAL = C_ERRO.CDFILIAL
                     AND NREXPEDICAO = C_ERRO.NREXPEDICAO
                     AND NRPEDIDO = C_ERRO.NRPEDIDO
                     AND NRITEMPED = C_ERRO.NRITEMPED
                     AND DSERRO = 'ALMOXENTR';
                  IF (V_ERRO = 0) THEN
                     INSERT INTO ERROITEMEXP
                     (CDFILIAL, NREXPEDICAO, NRPEDIDO, NRITEMPED, NRSEQERROITEM, CDFILIALPED, CDPRODUTO, DSERRO)
                     VALUES
                     (C_ERRO.CDFILIAL, C_ERRO.NREXPEDICAO, C_ERRO.NRPEDIDO, C_ERRO.NRITEMPED, V_NRSEQ, C_ERRO.CDFILIALPED, C_ERRO.CDPRODUTO, 'ALMOXENTR');
                  END IF;
               END IF;
            END IF;
/*------------------'ALMOXENTR'--------------*/

/*------------------'ALMOXLCESTENTR'--------------*/
            IF (V_IDUTILLCESTQ = 'S') THEN
               IF (V_CDLOCALPRCLI IS NULL) THEN
                  IF (V_CDALMOXARIFE <> V_CDALMOXPRCLI) THEN
                     IF NOT(V_CDLOCALESTOQ IS NULL) THEN
                        UPDATE ITEMEXPEDICAO
                           SET IDERRO = 'S'
                         WHERE CDFILIAL = C_ERRO.CDFILIAL
                           AND NREXPEDICAO = C_ERRO.NREXPEDICAO
                           AND NRPEDIDO = C_ERRO.NRPEDIDO
                           AND NRITEMPED = C_ERRO.NRITEMPED;

                        SELECT NVL(MAX(NRSEQERROITEM),0)
                          INTO V_NRSEQ
                          FROM ERROITEMEXP
                         WHERE CDFILIAL = C_ERRO.CDFILIAL
                           AND NREXPEDICAO = C_ERRO.NREXPEDICAO
                           AND NRPEDIDO = C_ERRO.NRPEDIDO;

                        V_NRSEQ := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_NRSEQ) + 1)),10,0);
                        V_ERRO := 0;
                        SELECT COUNT(1)
                          INTO V_ERRO
                          FROM ERROITEMEXP
                         WHERE CDFILIAL = C_ERRO.CDFILIAL
                           AND NREXPEDICAO = C_ERRO.NREXPEDICAO
                           AND NRPEDIDO = C_ERRO.NRPEDIDO
                           AND NRITEMPED = C_ERRO.NRITEMPED
                           AND DSERRO = 'ALMOXLCESTENTR';
                        IF (V_ERRO = 0) THEN
                           INSERT INTO ERROITEMEXP
                           (CDFILIAL, NREXPEDICAO, NRPEDIDO, NRITEMPED, NRSEQERROITEM, CDFILIALPED, CDPRODUTO, DSERRO)
                           VALUES
                           (C_ERRO.CDFILIAL, C_ERRO.NREXPEDICAO, C_ERRO.NRPEDIDO, C_ERRO.NRITEMPED, V_NRSEQ, C_ERRO.CDFILIALPED, C_ERRO.CDPRODUTO, 'ALMOXLCESTENTR');
                        END IF;
                     END IF;
                  END IF;
               END IF;
            END IF;
/*------------------'ALMOXLCESTENTR'--------------*/

/*------------------'LCESTENTR'--------------*/
            IF (V_IDUTILLCESTQ = 'S') THEN
               IF (V_CDLOCALPRCLI IS NULL) THEN
                  IF (V_CDLOCALESTOQ IS NULL) THEN
                     UPDATE ITEMEXPEDICAO
                        SET IDERRO = 'S'
                      WHERE CDFILIAL = C_ERRO.CDFILIAL
                        AND NREXPEDICAO = C_ERRO.NREXPEDICAO
                        AND NRPEDIDO = C_ERRO.NRPEDIDO
                        AND NRITEMPED = C_ERRO.NRITEMPED;

                     SELECT NVL(MAX(NRSEQERROITEM),0)
                       INTO V_NRSEQ
                       FROM ERROITEMEXP
                      WHERE CDFILIAL = C_ERRO.CDFILIAL
                        AND NREXPEDICAO = C_ERRO.NREXPEDICAO
                        AND NRPEDIDO = C_ERRO.NRPEDIDO;

                     V_NRSEQ := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_NRSEQ) + 1)),10,0);
                     V_ERRO := 0;
                     SELECT COUNT(1)
                       INTO V_ERRO
                       FROM ERROITEMEXP
                      WHERE CDFILIAL = C_ERRO.CDFILIAL
                        AND NREXPEDICAO = C_ERRO.NREXPEDICAO
                        AND NRPEDIDO = C_ERRO.NRPEDIDO
                        AND NRITEMPED = C_ERRO.NRITEMPED
                        AND DSERRO = 'LCESTENTR';
                     IF (V_ERRO = 0) THEN
                        INSERT INTO ERROITEMEXP
                        (CDFILIAL, NREXPEDICAO, NRPEDIDO, NRITEMPED, NRSEQERROITEM, CDFILIALPED, CDPRODUTO, DSERRO)
                        VALUES
                        (C_ERRO.CDFILIAL, C_ERRO.NREXPEDICAO, C_ERRO.NRPEDIDO, C_ERRO.NRITEMPED, V_NRSEQ, C_ERRO.CDFILIALPED, C_ERRO.CDPRODUTO, 'LCESTENTR');
                     END IF;
                  END IF;
               END IF;
            END IF;
/*------------------'LCESTENTR'--------------*/
         END IF;
/*------------------'LOTEENTR'--------------*/
         IF (V_IDUTILLOTE = 'S')  THEN
            IF ((V_DSNUMELOTE IS NULL) OR (V_DSSEQULOTE IS NULL)) THEN
               UPDATE ITEMEXPEDICAO
                  SET IDERRO = 'S'
                WHERE CDFILIAL = C_ERRO.CDFILIAL
                  AND NREXPEDICAO = C_ERRO.NREXPEDICAO
                  AND NRPEDIDO = C_ERRO.NRPEDIDO
                  AND NRITEMPED = C_ERRO.NRITEMPED;

               SELECT NVL(MAX(NRSEQERROITEM),0)
                 INTO V_NRSEQ
                 FROM ERROITEMEXP
                WHERE CDFILIAL = C_ERRO.CDFILIAL
                  AND NREXPEDICAO = C_ERRO.NREXPEDICAO
                  AND NRPEDIDO = C_ERRO.NRPEDIDO;

               V_NRSEQ := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_NRSEQ) + 1)),10,0);
               V_ERRO := 0;
               SELECT COUNT(1)
                 INTO V_ERRO
                 FROM ERROITEMEXP
                WHERE CDFILIAL = C_ERRO.CDFILIAL
                  AND NREXPEDICAO = C_ERRO.NREXPEDICAO
                  AND NRPEDIDO = C_ERRO.NRPEDIDO
                  AND NRITEMPED = C_ERRO.NRITEMPED
                  AND DSERRO = 'LOTEENTR';
               IF (V_ERRO = 0) THEN
                  INSERT INTO ERROITEMEXP
                  (CDFILIAL, NREXPEDICAO, NRPEDIDO, NRITEMPED, NRSEQERROITEM, CDFILIALPED, CDPRODUTO, DSERRO)
                  VALUES
                  (C_ERRO.CDFILIAL, C_ERRO.NREXPEDICAO, C_ERRO.NRPEDIDO, C_ERRO.NRITEMPED, V_NRSEQ, C_ERRO.CDFILIALPED, C_ERRO.CDPRODUTO, 'LOTEENTR');
               END IF;
            END IF;
         END IF;
/*------------------'LOTEENTR'--------------*/
      END LOOP;
  END IF;

/*------------------'LOTE_VENCIDO'--------------*/
   FOR C_ERRO IN (SELECT I.CDFILIAL, I.NREXPEDICAO, I.NRPEDIDO, I.NRITEMPED, I.CDPRODUTO, I.NRLOTEEXP, I.NRSUBLOTEEXP
                    FROM ITEMEXPEDICAO I LEFT JOIN LOTE L
                                                ON I.CDFILIAL = L.CDFILIAL
                                               AND I.CDPRODMOVI = L.CDPRODUTO
                                               AND I.NRLOTEEXP = L.NRLOTEESTQ
                                               AND I.NRSUBLOTEEXP = L.NRSUBLOTE
                   WHERE I.CDFILIAL = P_CDFILIAL
                     AND I.NREXPEDICAO = P_NREXPEDICAO
                     AND IDRESERVA = 'S'
                     AND ((I.IDUTCTRLLOTE = 'S') AND (TRUNC(L.DTVALILOTE) <= TRUNC(SYSDATE))))
   LOOP
      UPDATE ITEMEXPEDICAO
         SET IDERRO = 'S'
       WHERE CDFILIAL = C_ERRO.CDFILIAL
         AND NREXPEDICAO = C_ERRO.NREXPEDICAO
         AND NRPEDIDO = C_ERRO.NRPEDIDO
         AND NRITEMPED = C_ERRO.NRITEMPED;

      SELECT NVL(MAX(NRSEQERROITEM),0)
        INTO V_NRSEQ
        FROM ERROITEMEXP
       WHERE CDFILIAL = C_ERRO.CDFILIAL
         AND NREXPEDICAO = C_ERRO.NREXPEDICAO
         AND NRPEDIDO = C_ERRO.NRPEDIDO;

      V_NRSEQ := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_NRSEQ) + 1)),10,0);
      V_ERRO := 0;
      SELECT COUNT(1)
        INTO V_ERRO
        FROM ERROITEMEXP
       WHERE CDFILIAL = C_ERRO.CDFILIAL
         AND NREXPEDICAO = C_ERRO.NREXPEDICAO
         AND NRPEDIDO = C_ERRO.NRPEDIDO
         AND NRITEMPED = C_ERRO.NRITEMPED
         AND DSERRO = 'LOTE_VENCIDO';
      IF (V_ERRO = 0) THEN
         INSERT INTO ERROITEMEXP
         (CDFILIAL, NREXPEDICAO, NRPEDIDO, NRITEMPED, NRSEQERROITEM, CDPRODUTO, DSERRO)
         VALUES
         (C_ERRO.CDFILIAL, C_ERRO.NREXPEDICAO, C_ERRO.NRPEDIDO, C_ERRO.NRITEMPED, V_NRSEQ, C_ERRO.CDPRODUTO, 'LOTE_VENCIDO');
      END IF;
   END LOOP;
/*------------------'LOTE_VENCIDO'--------------*/

/*-------------------------FAZ A EXPEDICAO DOS ITENS SEM ERRO--------------------------*/
  FOR C_AGRUPAITENS IN (SELECT CDFILIAL, NREXPEDICAO, CDEMPRESA, CDINSCMUNI, CDINSCESTA, CDSERIE, CDQUEBRANF, IDTPIJURTRAN, NRINSJURTRAN, CDTIPTRANS, IDPGFRETTRAN, NRPLACAVEPED, SGUFVEICPED, CDMODPGTO, CDTIPOOPER, IDATUESTTPOP, CDVENDEDOR, COUNT(1)
                          FROM ITEMEXPEDICAO
                         WHERE CDFILIAL = P_CDFILIAL
                           AND NREXPEDICAO = P_NREXPEDICAO
                           AND IDERRO = 'N'
                        GROUP BY CDFILIAL, NREXPEDICAO, CDEMPRESA, CDINSCMUNI, CDINSCESTA, CDSERIE, CDQUEBRANF, IDTPIJURTRAN, NRINSJURTRAN, CDTIPTRANS, IDPGFRETTRAN, NRPLACAVEPED, SGUFVEICPED, CDMODPGTO , CDTIPOOPER, IDATUESTTPOP, CDVENDEDOR)
  LOOP
     BEGIN
        SELECT NVL(NRMAXITNF, 10), NVL(IDCONMAXITEM, 'S')
          INTO V_NRMAXITNF, V_IDCONMAXITEM
          FROM SERIENF
         WHERE CDEMPRESA = C_AGRUPAITENS.CDEMPRESA
           AND CDINSCMUNI = C_AGRUPAITENS.CDINSCMUNI
           AND CDINSCESTA = C_AGRUPAITENS.CDINSCESTA
           AND CDSERIE = C_AGRUPAITENS.CDSERIE;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           V_NRMAXITNF := 10;
           V_IDCONMAXITEM := 'S';

     END;
     V_NOVANOTA := '1';
     FOR C_ITEMNF IN (SELECT CDFILIAL, NREXPEDICAO, NRPEDIDO, NRITEMPED, CDPRODMOVI, CDPRODEMIS, DSPRODEMIS, CDDESTINO,
                             IDTPIJURTRAN, NRINSJURTRAN, CDTIPTRANS, IDPGFRETTRAN, NRPLACAVEPED,  SGUFVEICPED,
                             CDEMPRESA,   CDINSCESTA,   CDINSCMUNI,   CDSERIE, QTITEMPROD, CDALMOXEXP, CDLOCALEXP,
                             NRLOTEEXP, NRSUBLOTEEXP, VRPRECOEXP, VRDESITEXP, IDCNTRESTOQ, QTEXPEDIDA, QTITEMPED
                        FROM ITEMEXPEDICAO
                       WHERE CDFILIAL = C_AGRUPAITENS.CDFILIAL
                         AND NREXPEDICAO = C_AGRUPAITENS.NREXPEDICAO
                         AND CDEMPRESA = C_AGRUPAITENS.CDEMPRESA
                         AND CDINSCMUNI = C_AGRUPAITENS.CDINSCMUNI
                         AND CDINSCESTA = C_AGRUPAITENS.CDINSCESTA
                         AND NVL(CDSERIE, 'A') = NVL(C_AGRUPAITENS.CDSERIE, 'A')
                         AND NVL(CDQUEBRANF, 'A') = NVL(C_AGRUPAITENS.CDQUEBRANF, 'A')
                         AND NVL(IDTPIJURTRAN, 'A') = NVL(C_AGRUPAITENS.IDTPIJURTRAN, 'A')
                         AND NVL(NRINSJURTRAN, 'A') = NVL(C_AGRUPAITENS.NRINSJURTRAN, 'A')
                         AND NVL(CDTIPTRANS, 'A') = NVL(C_AGRUPAITENS.CDTIPTRANS, 'A')
                         AND IDPGFRETTRAN = C_AGRUPAITENS.IDPGFRETTRAN
                         AND CDMODPGTO = C_AGRUPAITENS.CDMODPGTO
                         AND CDTIPOOPER = C_AGRUPAITENS.CDTIPOOPER
                         AND CDVENDEDOR = C_AGRUPAITENS.CDVENDEDOR
                         AND IDERRO = 'N'
                      ORDER BY CDDESTINO, NRPEDIDO, NRITEMPED)
     LOOP
        IF (V_NOVANOTA = '1') THEN
           NOVO_CODIGO('LANCNF/FILIAL' || C_AGRUPAITENS.CDFILIAL,V_SEQNF);
           V_NRLANCTONF := SUBSTR(V_SEQNF,11,10);

           NOVO_CODIGO('LANCTOEST'|| C_AGRUPAITENS.CDFILIAL,V_SEQEST);
           V_PRXLANCESTQ := SUBSTR(V_SEQEST,11,10);

           V_ATUAESTOQUE := 'N';
           IF ((V_IDCTRLESTQ = 'S') AND (C_AGRUPAITENS.IDATUESTTPOP = 'S')) THEN
              V_ATUAESTOQUE := 'S';
           END IF;
           GERA_NOTAFISCAL_CORPO(C_AGRUPAITENS.CDFILIAL,   C_AGRUPAITENS.CDFILIAL,      C_AGRUPAITENS.CDEMPRESA,    C_AGRUPAITENS.CDTIPOOPER,   C_AGRUPAITENS.CDSERIE,     C_ITEMNF.CDDESTINO,
                                 V_DTEXPEDICAO,  'EXP',    V_NRLANCTONF,   V_PRXLANCESTQ,  V_ATUAESTOQUE, NULL,
                                 V_NRLANCTONF,  C_AGRUPAITENS.IDTPIJURTRAN, C_AGRUPAITENS.NRINSJURTRAN, C_AGRUPAITENS.NRPLACAVEPED, C_AGRUPAITENS.SGUFVEICPED, C_AGRUPAITENS.IDPGFRETTRAN,
                                 NULL,          NULL,           NULL,           NULL,           NULL,         NULL,
                                 V_PRXLANCESTQ, NULL,           V_DTEXPEDICAO,   NULL,           NULL,         NULL);
           V_NOVANOTA := '0';
           V_COUNTITEM := 0;
        END IF;
        GERA_NOTAFISCAL_PRODUTO(C_ITEMNF.CDFILIAL, V_NRLANCTONF,       C_ITEMNF.CDPRODMOVI,    C_ITEMNF.CDPRODEMIS, C_ITEMNF.DSPRODEMIS , C_ITEMNF.QTITEMPROD,
                                C_ITEMNF.VRPRECOEXP,    C_ITEMNF.VRDESITEXP, C_ITEMNF.CDFILIAL,     C_ITEMNF.NRPEDIDO,         C_ITEMNF.NRITEMPED,   NULL,
                                NULL,       NULL,       C_ITEMNF.CDALMOXEXP, C_ITEMNF.CDLOCALEXP,     C_ITEMNF.NRLOTEEXP,                C_ITEMNF.NRSUBLOTEEXP,
                                'S',        NULL,               NULL,           NULL,               NULL,                NULL,
                                 NULL,       'N',       C_ITEMNF.IDCNTRESTOQ,  NULL,                  NULL,                NULL,
                                 NULL);
        V_COUNTITEM := V_COUNTITEM + 1;

        IF (C_ITEMNF.QTEXPEDIDA + C_ITEMNF.QTITEMPROD >= C_ITEMNF.QTITEMPED) THEN
           V_IDSITITEMPED := '4';
        ELSE
           V_IDSITITEMPED := '7';
        END IF;
        UPDATE ITEMPEDIDO
           SET IDSITITEMPED = V_IDSITITEMPED,
               QTEXPITEMPED = QTEXPITEMPED + C_ITEMNF.QTITEMPROD,
               CDOPERADOR   = V_CDOPERADOR
         WHERE CDFILIAL  = C_ITEMNF.CDFILIAL
           AND NRPEDIDO  = C_ITEMNF.NRPEDIDO
           AND NRITEMPED = C_ITEMNF.NRITEMPED;
        V_EXISTENF := 0;
        SELECT COUNT(1)
          INTO V_EXISTENF
          FROM NFRELACITEMPED
         WHERE CDFILIAL = C_ITEMNF.CDFILIAL
           AND NREXPEDICAO = C_ITEMNF.NREXPEDICAO
           AND NRPEDIDO = C_ITEMNF.NRPEDIDO
           AND NRITEMPED = C_ITEMNF.NRITEMPED
           AND NRLANCTONF = V_NRLANCTONF;
        IF (V_EXISTENF = 0) THEN
           INSERT INTO NFRELACITEMPED
           (CDFILIAL, NREXPEDICAO, NRPEDIDO, NRITEMPED, NRLANCTONF , NRLANCESTQ, IDATUAESTOQUE, IDERRO)
           VALUES
           (C_ITEMNF.CDFILIAL, C_ITEMNF.NREXPEDICAO, C_ITEMNF.NRPEDIDO, C_ITEMNF.NRITEMPED, V_NRLANCTONF, V_PRXLANCESTQ, V_ATUAESTOQUE, 'N');
        END IF;

        IF (V_IDLANENCARGOPED = 'S') THEN
           FOR C_ENCARGOS IN (SELECT EP.CDENCARGO, EP.VRENCARGOPED
                                FROM ENCARGOPED EP
                               WHERE EP.CDFILIAL  = C_ITEMNF.CDFILIAL
                                 AND EP.NRPEDIDO  = C_ITEMNF.NRPEDIDO)
           LOOP
              IF (C_ENCARGOS.VRENCARGOPED > 0) THEN
                 GERA_NOTAFISCAL_ENCARGO(C_ITEMNF.CDFILIAL, V_NRLANCTONF,C_ENCARGOS.CDENCARGO, C_ENCARGOS.VRENCARGOPED);
              END IF;
           END LOOP;
        END IF;

        FOR C_DADOSADIC IN (SELECT NRDADOADICPED, CDMENSAGEM, DSDADOADICPED
                              FROM DADOSADICPED
                             WHERE CDFILIAL = C_ITEMNF.CDFILIAL
                               AND NRPEDIDO = C_ITEMNF.NRPEDIDO)
        LOOP
           GERA_NOTAFISCAL_DADOSADIC (C_ITEMNF.CDFILIAL, V_NRLANCTONF, NULL, NULL, C_DADOSADIC.DSDADOADICPED, C_DADOSADIC.CDMENSAGEM);
        END LOOP;

        IF ((V_COUNTITEM = V_NRMAXITNF) AND (V_IDCONMAXITEM = 'S')) THEN
           V_NOVANOTA := '1';
        END IF;
     END LOOP;
  END LOOP;

  FOR C_NF IN (SELECT DISTINCT CDFILIAL, NREXPEDICAO, NRLANCTONF, NRLANCESTQ, IDATUAESTOQUE
                 FROM NFRELACITEMPED N
                WHERE CDFILIAL = P_CDFILIAL
                  AND NREXPEDICAO = P_NREXPEDICAO)
  LOOP

     FOR C_EXCLUIRESERVA IN (SELECT DISTINCT CDFILIAL, NREXPEDICAO, NRPEDIDO, NRITEMPED
                               FROM NFRELACITEMPED
                              WHERE CDFILIAL = C_NF.CDFILIAL
                                AND NREXPEDICAO = C_NF.NREXPEDICAO
                                AND NRLANCTONF = C_NF.NRLANCTONF)
     LOOP
        DELETE FROM RESERPRODPED
        WHERE CDFILIAL = C_EXCLUIRESERVA.CDFILIAL
          AND NRPEDIDO = C_EXCLUIRESERVA.NRPEDIDO
          AND NRITEMPED = C_EXCLUIRESERVA.NRITEMPED;
     END LOOP;

     GERA_NOTAFISCAL_FECHAMENTO(C_NF.CDFILIAL, C_NF.NRLANCTONF, V_DTEXPEDICAO, C_NF.NRLANCESTQ, 'S', V_CDOPERADOR, 'N', C_NF.IDATUAESTOQUE);


     IF V_DTEXPEDICAO < V_DTPROCESSA THEN
        V_DTINICIAL := V_DTEXPEDICAO;
     ELSE
        V_DTINICIAL := V_DTEXPEDICAO;
     END IF;

     IF V_DTEXPEDICAO > V_DTPROCESSA THEN
        V_DTFINAL := V_DTEXPEDICAO;
     ELSE
        V_DTFINAL := V_DTPROCESSA;
     END IF;
     BEGIN
        SELECT DTLANCESTQ
          INTO V_DTANTERIOR
          FROM LANCTOESTOQ
         WHERE CDFILIAL = C_NF.CDFILIAL
           AND NRLANCESTQ = C_NF.NRLANCESTQ;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN BEGIN
           V_DTANTERIOR  := NULL;
        END;
     END;

     IF (V_DTANTERIOR IS NOT NULL) THEN
        IF(V_DTANTERIOR < V_DTINICIAL) THEN
           V_DTINICIAL := V_DTANTERIOR;
        END IF;
        IF(V_DTANTERIOR > V_DTFINAL) THEN
           V_DTFINAL := V_DTANTERIOR;
        END IF;
     END IF;

     ATUALIZA_ESTOQUE(C_NF.CDFILIAL, V_DTINICIAL, V_DTFINAL, C_NF.CDFILIAL, C_NF.NRLANCESTQ);

     V_ERROESTOQ := 0;
     FOR C_MOVILOTE IN (SELECT CDPRODUTO
                          FROM MOVILOTE
                         WHERE NRMOVILOTE  = C_NF.CDFILIAL||C_NF.NRLANCESTQ)
     LOOP
        V_ERROESTOQ := 1;
        FOR C_ITEMSESTOQ IN (SELECT NF.CDFILIAL, NF.NREXPEDICAO, NF.NRPEDIDO, NF.NRITEMPED
                              FROM NFRELACITEMPED NF JOIN ITEMEXPEDICAO IE
                                                       ON NF.CDFILIAL = IE.CDFILIAL
                                                      AND NF.NREXPEDICAO = IE.NREXPEDICAO
                                                      AND NF.NRPEDIDO = IE.NRPEDIDO
                                                      AND NF.NRITEMPED = IE.NRITEMPED
                             WHERE NF.CDFILIAL = C_NF.CDFILIAL
                               AND NF.NREXPEDICAO = C_NF.NREXPEDICAO
                               AND NF.NRLANCTONF = C_NF.NRLANCTONF
                               AND IE.CDPRODMOVI = C_MOVILOTE.CDPRODUTO)
        LOOP
           UPDATE ITEMEXPEDICAO
              SET IDERRO = 'S'
            WHERE CDFILIAL = C_ITEMSESTOQ.CDFILIAL
              AND NREXPEDICAO = C_ITEMSESTOQ.NREXPEDICAO
              AND NRPEDIDO = C_ITEMSESTOQ.NRPEDIDO
              AND NRITEMPED = C_ITEMSESTOQ.NRITEMPED;

           SELECT NVL(MAX(NRSEQERROITEM),0)
             INTO V_NRSEQ
             FROM ERROITEMEXP
            WHERE CDFILIAL = C_ITEMSESTOQ.CDFILIAL
              AND NREXPEDICAO = C_ITEMSESTOQ.NREXPEDICAO
              AND NRPEDIDO = C_ITEMSESTOQ.NRPEDIDO
              AND NRITEMPED = C_ITEMSESTOQ.NRITEMPED;

           V_NRSEQ := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_NRSEQ) + 1)),10,0);
           SELECT COUNT(1)
             INTO V_ERRO
             FROM ERROITEMEXP
            WHERE CDFILIAL = C_ITEMSESTOQ.CDFILIAL
              AND NREXPEDICAO = C_ITEMSESTOQ.NREXPEDICAO
              AND NRPEDIDO = C_ITEMSESTOQ.NRPEDIDO
              AND NRITEMPED = C_ITEMSESTOQ.NRITEMPED
              AND DSERRO = 'IRREGESTOQ';
           IF (V_ERRO = 0) THEN
              INSERT INTO ERROITEMEXP
              (CDFILIAL, NREXPEDICAO, NRPEDIDO, NRITEMPED, NRSEQERROITEM, DSERRO)
              VALUES
              (C_ITEMSESTOQ.CDFILIAL, C_ITEMSESTOQ.NREXPEDICAO, C_ITEMSESTOQ.NRPEDIDO, C_ITEMSESTOQ.NRITEMPED, V_NRSEQ, 'IRREGESTOQ');
           END IF;
        END LOOP;

        UPDATE NFRELACITEMPED
           SET IDERRO = 'S'
         WHERE CDFILIAL = C_NF.CDFILIAL
           AND NREXPEDICAO = C_NF.NREXPEDICAO
           AND NRLANCTONF = C_NF.NRLANCTONF;

        DELETA_NF(C_NF.CDFILIAL, C_NF.NRLANCTONF);
     END LOOP;
     IF (V_ERROESTOQ = 0) THEN
        FOR C_PEDIDO IN (SELECT DISTINCT CDFILIAL, NREXPEDICAO, NRPEDIDO
                           FROM NFRELACITEMPED
                          WHERE CDFILIAL = C_NF.CDFILIAL
                            AND NREXPEDICAO = C_NF.NREXPEDICAO
                            AND NRLANCTONF = C_NF.NRLANCTONF)
        LOOP
           SELECT COUNT(1)
             INTO V_ITEMPA
             FROM ITEMPEDIDO IT
            WHERE IT.CDFILIAL = C_PEDIDO.CDFILIAL
              AND IT.NRPEDIDO = C_PEDIDO.NRPEDIDO
              AND IT.IDSITITEMPED IN ('1','2','3','7');

           IF (V_ITEMPA > 0) THEN
              V_IDSITPEDIDO := '6';
           ELSE
              V_IDSITPEDIDO := '3';
           END IF;
           UPDATE PEDIDO
              SET IDSITPEDIDO = V_IDSITPEDIDO
            WHERE CDFILIAL = C_PEDIDO.CDFILIAL
              AND NRPEDIDO = C_PEDIDO.NRPEDIDO;
        END LOOP;

        UPDATE NOTAFISCAL
           SET NREXPEDICAO = C_NF.NREXPEDICAO
         WHERE CDFILIAL = C_NF.CDFILIAL
           AND NRLANCTONF = C_NF.NRLANCTONF;

        /*--------------------------REPLICACAO------------------------*/
        IF (V_IDGERAREPLIC = '2') THEN
           IF ((P_CDSERIEENTR IS NOT NULL) AND (P_CDTPOPERENTR IS NOT NULL)) THEN
              BEGIN
                 SELECT MAX(P.CDFILIALPED)
                   INTO V_CDFILIDEST
                   FROM ITEMPRODUTO I JOIN PEDIDO P
                                        ON I.CDFILIALPED = P.CDFILIAL
                                       AND I.NRPEDIDO = P.NRPEDIDO
                  WHERE I.CDFILIAL = C_NF.CDFILIAL
                    AND I.NRLANCTONF = C_NF.NRLANCTONF;
              EXCEPTION
                 WHEN NO_DATA_FOUND THEN BEGIN
                    V_CDFILIDEST  := NULL;
                 END;
              END;

              BEGIN
                 SELECT CDTIPOOPER
                   INTO V_CDTIPOOPERORIG
                   FROM NOTAFISCAL
                  WHERE CDFILIAL = C_NF.CDFILIAL
                    AND NRLANCTONF = C_NF.NRLANCTONF;
              EXCEPTION
                 WHEN NO_DATA_FOUND THEN BEGIN
                    V_CDTIPOOPERORIG  := NULL;
                 END;
              END;
              GERAR_EXP_REPLICACAO(C_NF.CDFILIAL, C_NF.NRLANCTONF, V_CDTIPOOPERORIG, V_CDFILIDEST, P_CDTPOPERENTR, P_CDSERIEENTR, NULL);
           END IF;
        END IF;

     END IF;
  END LOOP;
  V_QTNF := 0;
  SELECT COUNT(1)
    INTO V_QTNF
    FROM NFRELACITEMPED
   WHERE CDFILIAL = P_CDFILIAL
     AND NREXPEDICAO = P_NREXPEDICAO;
  V_NAOOK := 0;
  SELECT COUNT(1)
    INTO V_NAOOK
    FROM NFRELACITEMPED
   WHERE CDFILIAL = P_CDFILIAL
     AND NREXPEDICAO = P_NREXPEDICAO
     AND IDERRO = 'S';
  IF (V_NAOOK = V_QTNF) THEN
     P_IDSTATUSEXP := 'NAO_OK';
  ELSE
     V_OKNF := 0;
     SELECT COUNT(1)
       INTO V_OKNF
       FROM NFRELACITEMPED
      WHERE CDFILIAL = P_CDFILIAL
        AND NREXPEDICAO = P_NREXPEDICAO
        AND IDERRO = 'S';

     V_OKITEMPED := 0;
     SELECT COUNT(1)
       INTO V_OKITEMPED
       FROM ITEMEXPEDICAO
      WHERE CDFILIAL = P_CDFILIAL
        AND NREXPEDICAO = P_NREXPEDICAO
        AND IDERRO = 'S';

     IF ((V_OKNF = 0) AND (V_OKITEMPED = 0)) THEN
        P_IDSTATUSEXP := 'OK_0';
     ELSE
        P_IDSTATUSEXP := 'OK_1';
     END IF;
  END IF;
  UPDATE EXPEDICAO
     SET IDSTATUSEXP = P_IDSTATUSEXP
   WHERE CDFILIAL = P_CDFILIAL
     AND NREXPEDICAO = P_NREXPEDICAO;
END;
/
-- VERSAO --
BEGIN ATUVEROBJ('GERA_EXPEDICAO','6.49.xxx'); END;
/
